/* DrawingService.c generated by valac 0.22.1, the Vala compiler
 * generated from DrawingService.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gee.h>
#include <gtk/gtk.h>


#define PLANK_DRAWING_TYPE_DRAWING_SERVICE (plank_drawing_drawing_service_get_type ())
#define PLANK_DRAWING_DRAWING_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_DRAWING_TYPE_DRAWING_SERVICE, PlankDrawingDrawingService))
#define PLANK_DRAWING_DRAWING_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_DRAWING_TYPE_DRAWING_SERVICE, PlankDrawingDrawingServiceClass))
#define PLANK_DRAWING_IS_DRAWING_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_DRAWING_TYPE_DRAWING_SERVICE))
#define PLANK_DRAWING_IS_DRAWING_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_DRAWING_TYPE_DRAWING_SERVICE))
#define PLANK_DRAWING_DRAWING_SERVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_DRAWING_TYPE_DRAWING_SERVICE, PlankDrawingDrawingServiceClass))

typedef struct _PlankDrawingDrawingService PlankDrawingDrawingService;
typedef struct _PlankDrawingDrawingServiceClass PlankDrawingDrawingServiceClass;
typedef struct _PlankDrawingDrawingServicePrivate PlankDrawingDrawingServicePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define PLANK_DRAWING_TYPE_COLOR (plank_drawing_color_get_type ())
typedef GdkRGBA PlankDrawingColor;

struct _PlankDrawingDrawingService {
	GObject parent_instance;
	PlankDrawingDrawingServicePrivate * priv;
};

struct _PlankDrawingDrawingServiceClass {
	GObjectClass parent_class;
};


static gpointer plank_drawing_drawing_service_parent_class = NULL;

GType plank_drawing_drawing_service_get_type (void) G_GNUC_CONST;
enum  {
	PLANK_DRAWING_DRAWING_SERVICE_DUMMY_PROPERTY
};
#define PLANK_DRAWING_DRAWING_SERVICE_MISSING_ICONS "application-default-icon;;application-x-executable"
#define PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON "metadata::custom-icon"
#define PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME "metadata::custom-icon-name"
#define PLANK_DRAWING_DRAWING_SERVICE_SATURATION_WEIGHT 1.5
#define PLANK_DRAWING_DRAWING_SERVICE_WEIGHT_THRESHOLD 1.0
#define PLANK_DRAWING_DRAWING_SERVICE_ALPHA_THRESHOLD ((guint8) 24)
static PlankDrawingDrawingService* plank_drawing_drawing_service_new (void);
static PlankDrawingDrawingService* plank_drawing_drawing_service_construct (GType object_type);
gchar* plank_drawing_drawing_service_get_icon_from_file (GFile* file);
gchar* plank_drawing_drawing_service_get_icon_from_gicon (GIcon* icon);
GdkPixbuf* plank_drawing_drawing_service_load_icon (const gchar* names, gint width, gint height);
GFile* plank_drawing_drawing_service_try_get_icon_file (const gchar* name);
static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf_from_file (GFile* file, gint width, gint height);
static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf (const gchar* icon, gint size);
GdkPixbuf* plank_drawing_drawing_service_ar_scale (GdkPixbuf* source, gint width, gint height);
static GdkPixbuf* plank_drawing_drawing_service_get_empty_pixbuf (gint width, gint height);
GType plank_drawing_color_get_type (void) G_GNUC_CONST;
PlankDrawingColor* plank_drawing_color_dup (const PlankDrawingColor* self);
void plank_drawing_color_free (PlankDrawingColor* self);
void plank_drawing_drawing_service_average_color (GdkPixbuf* source, PlankDrawingColor* result);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static PlankDrawingDrawingService* plank_drawing_drawing_service_construct (GType object_type) {
	PlankDrawingDrawingService * self = NULL;
	self = (PlankDrawingDrawingService*) g_object_new (object_type, NULL);
	return self;
}


static PlankDrawingDrawingService* plank_drawing_drawing_service_new (void) {
	return plank_drawing_drawing_service_construct (PLANK_DRAWING_TYPE_DRAWING_SERVICE);
}


/**
 * Gets the icon name from a {@link GLib.File}.
 *
 * @param file the file to get the icon name for
 * @return the icon name for the file, or null if none exists
 */
gchar* plank_drawing_drawing_service_get_icon_from_file (GFile* file) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	{
		GFileInfo* info = NULL;
		GFile* _tmp0_ = NULL;
		GFileInfo* _tmp1_ = NULL;
		const gchar* custom_icon_name = NULL;
		GFileInfo* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		const gchar* _tmp5_ = NULL;
		gboolean _tmp7_ = FALSE;
		const gchar* custom_icon = NULL;
		GFileInfo* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		gboolean _tmp12_ = FALSE;
		const gchar* _tmp13_ = NULL;
		gboolean _tmp15_ = FALSE;
		const gchar* thumb_icon = NULL;
		GFileInfo* _tmp26_ = NULL;
		const gchar* _tmp27_ = NULL;
		gboolean _tmp28_ = FALSE;
		const gchar* _tmp29_ = NULL;
		gboolean _tmp31_ = FALSE;
		GFileInfo* _tmp34_ = NULL;
		GIcon* _tmp35_ = NULL;
		gchar* _tmp36_ = NULL;
		_tmp0_ = file;
		_tmp1_ = g_file_query_info (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_ICON "," PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME "," PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON "," G_FILE_ATTRIBUTE_THUMBNAIL_PATH, 0, NULL, &_inner_error_);
		info = _tmp1_;
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		_tmp2_ = info;
		_tmp3_ = g_file_info_get_attribute_string (_tmp2_, PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME);
		custom_icon_name = _tmp3_;
		_tmp5_ = custom_icon_name;
		if (_tmp5_ != NULL) {
			const gchar* _tmp6_ = NULL;
			_tmp6_ = custom_icon_name;
			_tmp4_ = g_strcmp0 (_tmp6_, "") != 0;
		} else {
			_tmp4_ = FALSE;
		}
		_tmp7_ = _tmp4_;
		if (_tmp7_) {
			const gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			_tmp8_ = custom_icon_name;
			_tmp9_ = g_strdup (_tmp8_);
			result = _tmp9_;
			_g_object_unref0 (info);
			return result;
		}
		_tmp10_ = info;
		_tmp11_ = g_file_info_get_attribute_string (_tmp10_, PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON);
		custom_icon = _tmp11_;
		_tmp13_ = custom_icon;
		if (_tmp13_ != NULL) {
			const gchar* _tmp14_ = NULL;
			_tmp14_ = custom_icon;
			_tmp12_ = g_strcmp0 (_tmp14_, "") != 0;
		} else {
			_tmp12_ = FALSE;
		}
		_tmp15_ = _tmp12_;
		if (_tmp15_) {
			const gchar* _tmp16_ = NULL;
			gboolean _tmp17_ = FALSE;
			GFile* _tmp20_ = NULL;
			const gchar* _tmp21_ = NULL;
			GFile* _tmp22_ = NULL;
			GFile* _tmp23_ = NULL;
			gchar* _tmp24_ = NULL;
			gchar* _tmp25_ = NULL;
			_tmp16_ = custom_icon;
			_tmp17_ = g_str_has_prefix (_tmp16_, "file://");
			if (_tmp17_) {
				const gchar* _tmp18_ = NULL;
				gchar* _tmp19_ = NULL;
				_tmp18_ = custom_icon;
				_tmp19_ = g_strdup (_tmp18_);
				result = _tmp19_;
				_g_object_unref0 (info);
				return result;
			}
			_tmp20_ = file;
			_tmp21_ = custom_icon;
			_tmp22_ = g_file_get_child (_tmp20_, _tmp21_);
			_tmp23_ = _tmp22_;
			_tmp24_ = g_file_get_path (_tmp23_);
			_tmp25_ = _tmp24_;
			_g_object_unref0 (_tmp23_);
			result = _tmp25_;
			_g_object_unref0 (info);
			return result;
		}
		_tmp26_ = info;
		_tmp27_ = g_file_info_get_attribute_byte_string (_tmp26_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH);
		thumb_icon = _tmp27_;
		_tmp29_ = thumb_icon;
		if (_tmp29_ != NULL) {
			const gchar* _tmp30_ = NULL;
			_tmp30_ = thumb_icon;
			_tmp28_ = g_strcmp0 (_tmp30_, "") != 0;
		} else {
			_tmp28_ = FALSE;
		}
		_tmp31_ = _tmp28_;
		if (_tmp31_) {
			const gchar* _tmp32_ = NULL;
			gchar* _tmp33_ = NULL;
			_tmp32_ = thumb_icon;
			_tmp33_ = g_strdup (_tmp32_);
			result = _tmp33_;
			_g_object_unref0 (info);
			return result;
		}
		_tmp34_ = info;
		_tmp35_ = g_file_info_get_icon (_tmp34_);
		_tmp36_ = plank_drawing_drawing_service_get_icon_from_gicon (_tmp35_);
		result = _tmp36_;
		_g_object_unref0 (info);
		return result;
	}
	goto __finally1;
	__catch1_g_error:
	{
		gchar* _tmp37_ = NULL;
		GFile* _tmp38_ = NULL;
		gchar* _tmp39_ = NULL;
		const gchar* _tmp40_ = NULL;
		const gchar* _tmp42_ = NULL;
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
		_tmp38_ = file;
		_tmp39_ = g_file_get_path (_tmp38_);
		_tmp37_ = _tmp39_;
		_tmp40_ = _tmp37_;
		if (_tmp40_ == NULL) {
			gchar* _tmp41_ = NULL;
			_tmp41_ = g_strdup ("");
			_g_free0 (_tmp37_);
			_tmp37_ = _tmp41_;
		}
		_tmp42_ = _tmp37_;
		g_debug ("DrawingService.vala:73: Could not get file info for '%s'", _tmp42_);
		_g_free0 (_tmp37_);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = NULL;
	return result;
}


/**
 * Gets an icon from a {@link GLib.Icon}.
 *
 * @param icon the icon to get the name for
 * @return the icon name, or null if none exists
 */
static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch2_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch2_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp5_;
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally2;
	__catch2_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar* plank_drawing_drawing_service_get_icon_from_gicon (GIcon* icon) {
	gchar* result = NULL;
	GIcon* _tmp0_ = NULL;
	GIcon* _tmp7_ = NULL;
	_tmp0_ = icon;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_themed_icon_get_type ())) {
		gchar* icons = NULL;
		GIcon* _tmp1_ = NULL;
		gchar** _tmp2_ = NULL;
		gchar** _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp1_ = icon;
		_tmp3_ = _tmp2_ = g_themed_icon_get_names (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_themed_icon_get_type (), GThemedIcon));
		_tmp4_ = g_strjoinv (";;", _tmp3_);
		icons = _tmp4_;
		_tmp5_ = icons;
		_tmp6_ = string_replace (_tmp5_, "(null);;", "");
		result = _tmp6_;
		_g_free0 (icons);
		return result;
	}
	_tmp7_ = icon;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, g_file_icon_get_type ())) {
		GIcon* _tmp8_ = NULL;
		GFile* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		_tmp8_ = icon;
		_tmp9_ = g_file_icon_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_file_icon_get_type (), GFileIcon));
		_tmp10_ = g_file_get_path (_tmp9_);
		result = _tmp10_;
		return result;
	}
	result = NULL;
	return result;
}


/**
 * Loads an icon based on names and the given width/height
 *
 * @param names a delimited (with ";;") list of icon names, first one found is used
 * @param width the requested width of the icon
 * @param height the requested height of the icon
 * @return the pixbuf representing the requested icon
 */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GdkPixbuf* plank_drawing_drawing_service_load_icon (const gchar* names, gint width, gint height) {
	GdkPixbuf* result = NULL;
	GeeArrayList* all_names = NULL;
	GeeArrayList* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gchar** _tmp6_ = NULL;
	gchar** _tmp7_ = NULL;
	GdkPixbuf* pbuf = NULL;
	GdkPixbuf* _tmp41_ = NULL;
	gint _tmp62_ = 0;
	gint _tmp63_ = 0;
	gint _tmp64_ = 0;
	gint _tmp65_ = 0;
	GdkPixbuf* _tmp66_ = NULL;
	g_return_val_if_fail (names != NULL, NULL);
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
	all_names = _tmp0_;
	_tmp1_ = names;
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, ";;", 0);
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = _tmp3_;
		s_collection_length1 = _vala_array_length (_tmp2_);
		for (s_it = 0; s_it < _vala_array_length (_tmp2_); s_it = s_it + 1) {
			const gchar* s = NULL;
			s = s_collection[s_it];
			{
				GeeArrayList* _tmp4_ = NULL;
				const gchar* _tmp5_ = NULL;
				_tmp4_ = all_names;
				_tmp5_ = s;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, _tmp5_);
			}
		}
		s_collection = (_vala_array_free (s_collection, s_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp7_ = _tmp6_ = g_strsplit (PLANK_DRAWING_DRAWING_SERVICE_MISSING_ICONS, ";;", 0);
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = _tmp7_;
		s_collection_length1 = _vala_array_length (_tmp6_);
		for (s_it = 0; s_it < _vala_array_length (_tmp6_); s_it = s_it + 1) {
			const gchar* s = NULL;
			s = s_collection[s_it];
			{
				GeeArrayList* _tmp8_ = NULL;
				const gchar* _tmp9_ = NULL;
				_tmp8_ = all_names;
				_tmp9_ = s;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
			}
		}
		s_collection = (_vala_array_free (s_collection, s_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	pbuf = NULL;
	{
		GeeArrayList* _name_list = NULL;
		GeeArrayList* _tmp10_ = NULL;
		GeeArrayList* _tmp11_ = NULL;
		gint _name_size = 0;
		GeeArrayList* _tmp12_ = NULL;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _name_index = 0;
		_tmp10_ = all_names;
		_tmp11_ = _g_object_ref0 (_tmp10_);
		_name_list = _tmp11_;
		_tmp12_ = _name_list;
		_tmp13_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp12_);
		_tmp14_ = _tmp13_;
		_name_size = _tmp14_;
		_name_index = -1;
		while (TRUE) {
			gint _tmp15_ = 0;
			gint _tmp16_ = 0;
			gint _tmp17_ = 0;
			gchar* name = NULL;
			GeeArrayList* _tmp18_ = NULL;
			gint _tmp19_ = 0;
			gpointer _tmp20_ = NULL;
			GFile* file = NULL;
			const gchar* _tmp21_ = NULL;
			GFile* _tmp22_ = NULL;
			GFile* _tmp23_ = NULL;
			const gchar* _tmp29_ = NULL;
			gint _tmp30_ = 0;
			gint _tmp31_ = 0;
			gint _tmp32_ = 0;
			GdkPixbuf* _tmp33_ = NULL;
			GdkPixbuf* _tmp34_ = NULL;
			const gchar* _tmp35_ = NULL;
			GeeArrayList* _tmp36_ = NULL;
			gpointer _tmp37_ = NULL;
			gchar* _tmp38_ = NULL;
			gboolean _tmp39_ = FALSE;
			_tmp15_ = _name_index;
			_name_index = _tmp15_ + 1;
			_tmp16_ = _name_index;
			_tmp17_ = _name_size;
			if (!(_tmp16_ < _tmp17_)) {
				break;
			}
			_tmp18_ = _name_list;
			_tmp19_ = _name_index;
			_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _tmp19_);
			name = (gchar*) _tmp20_;
			_tmp21_ = name;
			_tmp22_ = plank_drawing_drawing_service_try_get_icon_file (_tmp21_);
			file = _tmp22_;
			_tmp23_ = file;
			if (_tmp23_ != NULL) {
				GFile* _tmp24_ = NULL;
				gint _tmp25_ = 0;
				gint _tmp26_ = 0;
				GdkPixbuf* _tmp27_ = NULL;
				GdkPixbuf* _tmp28_ = NULL;
				_tmp24_ = file;
				_tmp25_ = width;
				_tmp26_ = height;
				_tmp27_ = plank_drawing_drawing_service_load_pixbuf_from_file (_tmp24_, _tmp25_, _tmp26_);
				_g_object_unref0 (pbuf);
				pbuf = _tmp27_;
				_tmp28_ = pbuf;
				if (_tmp28_ != NULL) {
					_g_object_unref0 (file);
					_g_free0 (name);
					break;
				}
			}
			_tmp29_ = name;
			_tmp30_ = width;
			_tmp31_ = height;
			_tmp32_ = MAX (_tmp30_, _tmp31_);
			_tmp33_ = plank_drawing_drawing_service_load_pixbuf (_tmp29_, _tmp32_);
			_g_object_unref0 (pbuf);
			pbuf = _tmp33_;
			_tmp34_ = pbuf;
			if (_tmp34_ != NULL) {
				_g_object_unref0 (file);
				_g_free0 (name);
				break;
			}
			_tmp35_ = name;
			_tmp36_ = all_names;
			_tmp37_ = gee_list_last ((GeeList*) _tmp36_);
			_tmp38_ = (gchar*) _tmp37_;
			_tmp39_ = g_strcmp0 (_tmp35_, _tmp38_) != 0;
			_g_free0 (_tmp38_);
			if (_tmp39_) {
				const gchar* _tmp40_ = NULL;
				_tmp40_ = name;
				g_message ("DrawingService.vala:131: Could not find icon '%s'", _tmp40_);
			}
			_g_object_unref0 (file);
			_g_free0 (name);
		}
		_g_object_unref0 (_name_list);
	}
	_tmp41_ = pbuf;
	if (_tmp41_ != NULL) {
		gboolean _tmp42_ = FALSE;
		gboolean _tmp43_ = FALSE;
		gint _tmp44_ = 0;
		gboolean _tmp46_ = FALSE;
		gboolean _tmp57_ = FALSE;
		_tmp44_ = width;
		if (_tmp44_ != (-1)) {
			gint _tmp45_ = 0;
			_tmp45_ = height;
			_tmp43_ = _tmp45_ != (-1);
		} else {
			_tmp43_ = FALSE;
		}
		_tmp46_ = _tmp43_;
		if (_tmp46_) {
			gboolean _tmp47_ = FALSE;
			gint _tmp48_ = 0;
			GdkPixbuf* _tmp49_ = NULL;
			gint _tmp50_ = 0;
			gint _tmp51_ = 0;
			gboolean _tmp56_ = FALSE;
			_tmp48_ = width;
			_tmp49_ = pbuf;
			_tmp50_ = gdk_pixbuf_get_width (_tmp49_);
			_tmp51_ = _tmp50_;
			if (_tmp48_ != _tmp51_) {
				_tmp47_ = TRUE;
			} else {
				gint _tmp52_ = 0;
				GdkPixbuf* _tmp53_ = NULL;
				gint _tmp54_ = 0;
				gint _tmp55_ = 0;
				_tmp52_ = height;
				_tmp53_ = pbuf;
				_tmp54_ = gdk_pixbuf_get_height (_tmp53_);
				_tmp55_ = _tmp54_;
				_tmp47_ = _tmp52_ != _tmp55_;
			}
			_tmp56_ = _tmp47_;
			_tmp42_ = _tmp56_;
		} else {
			_tmp42_ = FALSE;
		}
		_tmp57_ = _tmp42_;
		if (_tmp57_) {
			GdkPixbuf* _tmp58_ = NULL;
			gint _tmp59_ = 0;
			gint _tmp60_ = 0;
			GdkPixbuf* _tmp61_ = NULL;
			_tmp58_ = pbuf;
			_tmp59_ = width;
			_tmp60_ = height;
			_tmp61_ = plank_drawing_drawing_service_ar_scale (_tmp58_, _tmp59_, _tmp60_);
			result = _tmp61_;
			_g_object_unref0 (pbuf);
			_g_object_unref0 (all_names);
			return result;
		}
		result = pbuf;
		_g_object_unref0 (all_names);
		return result;
	}
	g_warning ("DrawingService.vala:140: No icon found, return empty pixbuf");
	_tmp62_ = width;
	_tmp63_ = MAX (1, _tmp62_);
	_tmp64_ = height;
	_tmp65_ = MAX (1, _tmp64_);
	_tmp66_ = plank_drawing_drawing_service_get_empty_pixbuf (_tmp63_, _tmp65_);
	result = _tmp66_;
	_g_object_unref0 (pbuf);
	_g_object_unref0 (all_names);
	return result;
}


static GdkPixbuf* plank_drawing_drawing_service_get_empty_pixbuf (gint width, gint height) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GdkPixbuf* _tmp2_ = NULL;
	_tmp0_ = width;
	_tmp1_ = height;
	_tmp2_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, _tmp0_, _tmp1_);
	pbuf = _tmp2_;
	gdk_pixbuf_fill (pbuf, (guint32) 0x00000000);
	result = pbuf;
	return result;
}


/**
 * Try to get a {@link GLib.File} for the given icon name
 *
 * @param name a string which might represent an existing file
 * @return a {@link GLib.File}, or null if it failed
 */
GFile* plank_drawing_drawing_service_try_get_icon_file (const gchar* name) {
	GFile* result = NULL;
	GFile* file = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp18_ = FALSE;
	GFile* _tmp19_ = NULL;
	gboolean _tmp22_ = FALSE;
	g_return_val_if_fail (name != NULL, NULL);
	file = NULL;
	_tmp0_ = name;
	_tmp1_ = g_utf8_strdown (_tmp0_, (gssize) (-1));
	_tmp2_ = _tmp1_;
	_tmp3_ = g_str_has_prefix (_tmp2_, "file://");
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	if (_tmp4_) {
		const gchar* _tmp5_ = NULL;
		GFile* _tmp6_ = NULL;
		_tmp5_ = name;
		_tmp6_ = g_file_new_for_uri (_tmp5_);
		_g_object_unref0 (file);
		file = _tmp6_;
	} else {
		const gchar* _tmp7_ = NULL;
		gboolean _tmp8_ = FALSE;
		_tmp7_ = name;
		_tmp8_ = g_str_has_prefix (_tmp7_, "~/");
		if (_tmp8_) {
			const gchar* _tmp9_ = NULL;
			const gchar* _tmp10_ = NULL;
			gchar* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
			GFile* _tmp13_ = NULL;
			_tmp9_ = name;
			_tmp10_ = g_get_home_dir ();
			_tmp11_ = string_replace (_tmp9_, "~", _tmp10_);
			_tmp12_ = _tmp11_;
			_tmp13_ = g_file_new_for_path (_tmp12_);
			_g_object_unref0 (file);
			file = _tmp13_;
			_g_free0 (_tmp12_);
		} else {
			const gchar* _tmp14_ = NULL;
			gboolean _tmp15_ = FALSE;
			_tmp14_ = name;
			_tmp15_ = g_str_has_prefix (_tmp14_, "/");
			if (_tmp15_) {
				const gchar* _tmp16_ = NULL;
				GFile* _tmp17_ = NULL;
				_tmp16_ = name;
				_tmp17_ = g_file_new_for_path (_tmp16_);
				_g_object_unref0 (file);
				file = _tmp17_;
			}
		}
	}
	_tmp19_ = file;
	if (_tmp19_ != NULL) {
		GFile* _tmp20_ = NULL;
		gboolean _tmp21_ = FALSE;
		_tmp20_ = file;
		_tmp21_ = g_file_query_exists (_tmp20_, NULL);
		_tmp18_ = _tmp21_;
	} else {
		_tmp18_ = FALSE;
	}
	_tmp22_ = _tmp18_;
	if (_tmp22_) {
		result = file;
		return result;
	}
	result = NULL;
	_g_object_unref0 (file);
	return result;
}


static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf_from_file (GFile* file, gint width, gint height) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	pbuf = NULL;
	{
		GdkPixbuf* _tmp0_ = NULL;
		GFile* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		GdkPixbuf* _tmp6_ = NULL;
		GdkPixbuf* _tmp7_ = NULL;
		_tmp1_ = file;
		_tmp2_ = g_file_get_path (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = width;
		_tmp5_ = height;
		_tmp6_ = gdk_pixbuf_new_from_file_at_size (_tmp3_, _tmp4_, _tmp5_, &_inner_error_);
		_tmp7_ = _tmp6_;
		_g_free0 (_tmp3_);
		_tmp0_ = _tmp7_;
		if (_inner_error_ != NULL) {
			goto __catch3_g_error;
		}
		_g_object_unref0 (pbuf);
		pbuf = _tmp0_;
	}
	goto __finally3;
	__catch3_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally3:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = pbuf;
	return result;
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf (const gchar* icon, gint size) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (icon != NULL, NULL);
	pbuf = NULL;
	_tmp0_ = gtk_icon_theme_get_default ();
	icon_theme = _tmp0_;
	{
		GdkPixbuf* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		GdkPixbuf* _tmp4_ = NULL;
		_tmp2_ = icon;
		_tmp3_ = size;
		_tmp4_ = gtk_icon_theme_load_icon (icon_theme, _tmp2_, _tmp3_, 0, &_inner_error_);
		_tmp1_ = _tmp4_;
		if (_inner_error_ != NULL) {
			goto __catch4_g_error;
		}
		_g_object_unref0 (pbuf);
		pbuf = _tmp1_;
	}
	goto __finally4;
	__catch4_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally4:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	{
		gboolean _tmp5_ = FALSE;
		GdkPixbuf* _tmp6_ = NULL;
		gboolean _tmp9_ = FALSE;
		_tmp6_ = pbuf;
		if (_tmp6_ == NULL) {
			const gchar* _tmp7_ = NULL;
			gboolean _tmp8_ = FALSE;
			_tmp7_ = icon;
			_tmp8_ = string_contains (_tmp7_, ".");
			_tmp5_ = _tmp8_;
		} else {
			_tmp5_ = FALSE;
		}
		_tmp9_ = _tmp5_;
		if (_tmp9_) {
			gchar** parts = NULL;
			const gchar* _tmp10_ = NULL;
			gchar** _tmp11_ = NULL;
			gchar** _tmp12_ = NULL;
			gint parts_length1 = 0;
			gint _parts_size_ = 0;
			GdkPixbuf* _tmp13_ = NULL;
			gchar** _tmp14_ = NULL;
			gint _tmp14__length1 = 0;
			const gchar* _tmp15_ = NULL;
			gint _tmp16_ = 0;
			GdkPixbuf* _tmp17_ = NULL;
			_tmp10_ = icon;
			_tmp12_ = _tmp11_ = g_strsplit (_tmp10_, ".", 0);
			parts = _tmp12_;
			parts_length1 = _vala_array_length (_tmp11_);
			_parts_size_ = parts_length1;
			_tmp14_ = parts;
			_tmp14__length1 = parts_length1;
			_tmp15_ = _tmp14_[0];
			_tmp16_ = size;
			_tmp17_ = gtk_icon_theme_load_icon (icon_theme, _tmp15_, _tmp16_, 0, &_inner_error_);
			_tmp13_ = _tmp17_;
			if (_inner_error_ != NULL) {
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
				goto __catch5_g_error;
			}
			_g_object_unref0 (pbuf);
			pbuf = _tmp13_;
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
		}
	}
	goto __finally5;
	__catch5_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally5:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = pbuf;
	return result;
}


/**
 * Scales a {@link Gdk.Pixbuf}, maintaining the original aspect ratio.
 *
 * @param source the pixbuf to scale
 * @param width the width of the scaled pixbuf
 * @param height the height of the scaled pixbuf
 * @return the scaled pixbuf
 */
GdkPixbuf* plank_drawing_drawing_service_ar_scale (GdkPixbuf* source, gint width, gint height) {
	GdkPixbuf* result = NULL;
	gdouble xScale = 0.0;
	gint _tmp0_ = 0;
	GdkPixbuf* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gdouble yScale = 0.0;
	gint _tmp4_ = 0;
	GdkPixbuf* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gdouble scale = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gint scaled_width = 0;
	GdkPixbuf* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gdouble _tmp17_ = 0.0;
	gint _tmp18_ = 0;
	gint scaled_height = 0;
	GdkPixbuf* _tmp19_ = NULL;
	gint _tmp20_ = 0;
	gint _tmp21_ = 0;
	gdouble _tmp22_ = 0.0;
	gint _tmp23_ = 0;
	GdkPixbuf* _tmp24_ = NULL;
	gint _tmp25_ = 0;
	gint _tmp26_ = 0;
	GdkPixbuf* _tmp27_ = NULL;
	g_return_val_if_fail (source != NULL, NULL);
	_tmp0_ = width;
	_tmp1_ = source;
	_tmp2_ = gdk_pixbuf_get_width (_tmp1_);
	_tmp3_ = _tmp2_;
	xScale = ((gdouble) _tmp0_) / ((gdouble) _tmp3_);
	_tmp4_ = height;
	_tmp5_ = source;
	_tmp6_ = gdk_pixbuf_get_height (_tmp5_);
	_tmp7_ = _tmp6_;
	yScale = ((gdouble) _tmp4_) / ((gdouble) _tmp7_);
	_tmp8_ = xScale;
	_tmp9_ = yScale;
	_tmp10_ = MIN (_tmp8_, _tmp9_);
	scale = _tmp10_;
	_tmp11_ = scale;
	if (_tmp11_ == ((gdouble) 1)) {
		GdkPixbuf* _tmp12_ = NULL;
		GdkPixbuf* _tmp13_ = NULL;
		_tmp12_ = source;
		_tmp13_ = _g_object_ref0 (_tmp12_);
		result = _tmp13_;
		return result;
	}
	_tmp14_ = source;
	_tmp15_ = gdk_pixbuf_get_width (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = scale;
	_tmp18_ = MAX (1, (gint) (_tmp16_ * _tmp17_));
	scaled_width = _tmp18_;
	_tmp19_ = source;
	_tmp20_ = gdk_pixbuf_get_height (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = scale;
	_tmp23_ = MAX (1, (gint) (_tmp21_ * _tmp22_));
	scaled_height = _tmp23_;
	_tmp24_ = source;
	_tmp25_ = scaled_width;
	_tmp26_ = scaled_height;
	_tmp27_ = gdk_pixbuf_scale_simple (_tmp24_, _tmp25_, _tmp26_, GDK_INTERP_HYPER);
	result = _tmp27_;
	return result;
}


/**
 * Computes and returns the average color of a {@link Gdk.Pixbuf}.
 * The resulting color is the average of all pixels which aren't
 * nearly transparent while saturated pixels are weighted more than
 * "grey" ones.
 *
 * @param source the pixbuf to use
 * @return the average color of the pixbuf
 */
void plank_drawing_drawing_service_average_color (GdkPixbuf* source, PlankDrawingColor* result) {
	guint8 r = 0U;
	guint8 g = 0U;
	guint8 b = 0U;
	guint8 a = 0U;
	guint8 min = 0U;
	guint8 max = 0U;
	gdouble delta = 0.0;
	gdouble rTotal = 0.0;
	gdouble gTotal = 0.0;
	gdouble bTotal = 0.0;
	gdouble bTotal2 = 0.0;
	gdouble gTotal2 = 0.0;
	gdouble rTotal2 = 0.0;
	gdouble aTotal2 = 0.0;
	guint8* dataPtr = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	guint8* _tmp1_ = NULL;
	gint n_channels = 0;
	GdkPixbuf* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint width = 0;
	GdkPixbuf* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gint height = 0;
	GdkPixbuf* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gint rowstride = 0;
	GdkPixbuf* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	gint length = 0;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	gint pixels = 0;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gdouble scoreTotal = 0.0;
	gint _tmp77_ = 0;
	gdouble _tmp79_ = 0.0;
	gint _tmp80_ = 0;
	gdouble _tmp81_ = 0.0;
	gint _tmp82_ = 0;
	gdouble _tmp83_ = 0.0;
	gint _tmp84_ = 0;
	gdouble _tmp85_ = 0.0;
	gint _tmp86_ = 0;
	gdouble _tmp87_ = 0.0;
	gdouble _tmp94_ = 0.0;
	gint _tmp95_ = 0;
	guint8 _tmp96_ = 0U;
	gdouble _tmp97_ = 0.0;
	gint _tmp98_ = 0;
	guint8 _tmp99_ = 0U;
	gdouble _tmp100_ = 0.0;
	gint _tmp101_ = 0;
	guint8 _tmp102_ = 0U;
	gdouble _tmp103_ = 0.0;
	gint _tmp104_ = 0;
	guint8 _tmp105_ = 0U;
	gdouble _tmp106_ = 0.0;
	gdouble max_val = 0.0;
	gdouble _tmp121_ = 0.0;
	gdouble _tmp122_ = 0.0;
	gdouble _tmp123_ = 0.0;
	gdouble _tmp124_ = 0.0;
	gdouble _tmp125_ = 0.0;
	gdouble _tmp126_ = 0.0;
	gdouble _tmp133_ = 0.0;
	gdouble _tmp134_ = 0.0;
	gdouble _tmp135_ = 0.0;
	gdouble _tmp136_ = 0.0;
	PlankDrawingColor _tmp137_ = {0};
	g_return_if_fail (source != NULL);
	rTotal = 0.0;
	gTotal = 0.0;
	bTotal = 0.0;
	bTotal2 = 0.0;
	gTotal2 = 0.0;
	rTotal2 = 0.0;
	aTotal2 = 0.0;
	_tmp0_ = source;
	_tmp1_ = gdk_pixbuf_get_pixels (_tmp0_);
	dataPtr = _tmp1_;
	_tmp2_ = source;
	_tmp3_ = gdk_pixbuf_get_n_channels (_tmp2_);
	_tmp4_ = _tmp3_;
	n_channels = _tmp4_;
	_tmp5_ = source;
	_tmp6_ = gdk_pixbuf_get_width (_tmp5_);
	_tmp7_ = _tmp6_;
	width = _tmp7_;
	_tmp8_ = source;
	_tmp9_ = gdk_pixbuf_get_height (_tmp8_);
	_tmp10_ = _tmp9_;
	height = _tmp10_;
	_tmp11_ = source;
	_tmp12_ = gdk_pixbuf_get_rowstride (_tmp11_);
	_tmp13_ = _tmp12_;
	rowstride = _tmp13_;
	_tmp14_ = width;
	_tmp15_ = height;
	length = _tmp14_ * _tmp15_;
	_tmp16_ = height;
	_tmp17_ = rowstride;
	_tmp18_ = n_channels;
	pixels = (_tmp16_ * _tmp17_) / _tmp18_;
	scoreTotal = 0.0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp19_ = FALSE;
			_tmp19_ = TRUE;
			while (TRUE) {
				gboolean _tmp20_ = FALSE;
				gint _tmp22_ = 0;
				gint _tmp23_ = 0;
				guint8* _tmp24_ = NULL;
				guint8 _tmp25_ = 0U;
				guint8* _tmp26_ = NULL;
				guint8 _tmp27_ = 0U;
				guint8* _tmp28_ = NULL;
				guint8 _tmp29_ = 0U;
				guint8* _tmp30_ = NULL;
				guint8 _tmp31_ = 0U;
				guint8 _tmp32_ = 0U;
				guint8 _tmp36_ = 0U;
				guint8 _tmp37_ = 0U;
				guint8 _tmp38_ = 0U;
				guint8 _tmp39_ = 0U;
				guint8 _tmp40_ = 0U;
				guint8 _tmp41_ = 0U;
				guint8 _tmp42_ = 0U;
				guint8 _tmp43_ = 0U;
				guint8 _tmp44_ = 0U;
				guint8 _tmp45_ = 0U;
				guint8 _tmp46_ = 0U;
				guint8 _tmp47_ = 0U;
				gdouble _tmp48_ = 0.0;
				gdouble _tmp49_ = 0.0;
				gdouble score = 0.0;
				gdouble _tmp52_ = 0.0;
				gdouble _tmp53_ = 0.0;
				gdouble _tmp54_ = 0.0;
				guint8 _tmp55_ = 0U;
				guint8 _tmp56_ = 0U;
				gdouble _tmp57_ = 0.0;
				gdouble _tmp58_ = 0.0;
				guint8 _tmp59_ = 0U;
				guint8 _tmp60_ = 0U;
				gdouble _tmp61_ = 0.0;
				gdouble _tmp62_ = 0.0;
				guint8 _tmp63_ = 0U;
				guint8 _tmp64_ = 0U;
				gdouble _tmp65_ = 0.0;
				gdouble _tmp66_ = 0.0;
				gdouble _tmp67_ = 0.0;
				guint8 _tmp68_ = 0U;
				gdouble _tmp69_ = 0.0;
				guint8 _tmp70_ = 0U;
				gdouble _tmp71_ = 0.0;
				guint8 _tmp72_ = 0U;
				gdouble _tmp73_ = 0.0;
				guint8 _tmp74_ = 0U;
				guint8* _tmp75_ = NULL;
				gint _tmp76_ = 0;
				_tmp20_ = _tmp19_;
				if (!_tmp20_) {
					gint _tmp21_ = 0;
					_tmp21_ = i;
					i = _tmp21_ + 1;
				}
				_tmp19_ = FALSE;
				_tmp22_ = i;
				_tmp23_ = pixels;
				if (!(_tmp22_ < _tmp23_)) {
					break;
				}
				_tmp24_ = dataPtr;
				_tmp25_ = _tmp24_[0];
				r = _tmp25_;
				_tmp26_ = dataPtr;
				_tmp27_ = _tmp26_[1];
				g = _tmp27_;
				_tmp28_ = dataPtr;
				_tmp29_ = _tmp28_[2];
				b = _tmp29_;
				_tmp30_ = dataPtr;
				_tmp31_ = _tmp30_[3];
				a = _tmp31_;
				_tmp32_ = a;
				if (_tmp32_ <= PLANK_DRAWING_DRAWING_SERVICE_ALPHA_THRESHOLD) {
					gint _tmp33_ = 0;
					guint8* _tmp34_ = NULL;
					gint _tmp35_ = 0;
					_tmp33_ = length;
					length = _tmp33_ - 1;
					_tmp34_ = dataPtr;
					_tmp35_ = n_channels;
					dataPtr = _tmp34_ + _tmp35_;
					continue;
				}
				_tmp36_ = r;
				_tmp37_ = g;
				_tmp38_ = b;
				_tmp39_ = MIN (_tmp37_, _tmp38_);
				_tmp40_ = MIN (_tmp36_, _tmp39_);
				min = _tmp40_;
				_tmp41_ = r;
				_tmp42_ = g;
				_tmp43_ = b;
				_tmp44_ = MAX (_tmp42_, _tmp43_);
				_tmp45_ = MAX (_tmp41_, _tmp44_);
				max = _tmp45_;
				_tmp46_ = max;
				_tmp47_ = min;
				delta = (gdouble) (_tmp46_ - _tmp47_);
				_tmp49_ = delta;
				if (_tmp49_ == ((gdouble) 0)) {
					_tmp48_ = 0.0;
				} else {
					gdouble _tmp50_ = 0.0;
					guint8 _tmp51_ = 0U;
					_tmp50_ = delta;
					_tmp51_ = max;
					_tmp48_ = _tmp50_ / _tmp51_;
				}
				_tmp52_ = _tmp48_;
				score = PLANK_DRAWING_DRAWING_SERVICE_SATURATION_WEIGHT * _tmp52_;
				_tmp53_ = bTotal;
				_tmp54_ = score;
				_tmp55_ = b;
				_tmp56_ = a;
				bTotal = _tmp53_ + ((_tmp54_ * _tmp55_) / _tmp56_);
				_tmp57_ = gTotal;
				_tmp58_ = score;
				_tmp59_ = g;
				_tmp60_ = a;
				gTotal = _tmp57_ + ((_tmp58_ * _tmp59_) / _tmp60_);
				_tmp61_ = rTotal;
				_tmp62_ = score;
				_tmp63_ = r;
				_tmp64_ = a;
				rTotal = _tmp61_ + ((_tmp62_ * _tmp63_) / _tmp64_);
				_tmp65_ = scoreTotal;
				_tmp66_ = score;
				scoreTotal = _tmp65_ + _tmp66_;
				_tmp67_ = bTotal2;
				_tmp68_ = b;
				bTotal2 = _tmp67_ + _tmp68_;
				_tmp69_ = gTotal2;
				_tmp70_ = g;
				gTotal2 = _tmp69_ + _tmp70_;
				_tmp71_ = rTotal2;
				_tmp72_ = r;
				rTotal2 = _tmp71_ + _tmp72_;
				_tmp73_ = aTotal2;
				_tmp74_ = a;
				aTotal2 = _tmp73_ + _tmp74_;
				_tmp75_ = dataPtr;
				_tmp76_ = n_channels;
				dataPtr = _tmp75_ + _tmp76_;
			}
		}
	}
	_tmp77_ = length;
	if (_tmp77_ <= 0) {
		PlankDrawingColor _tmp78_ = {0};
		_tmp78_.red = 0.0;
		_tmp78_.green = 0.0;
		_tmp78_.blue = 0.0;
		_tmp78_.alpha = 0.0;
		*result = _tmp78_;
		return;
	}
	_tmp79_ = scoreTotal;
	_tmp80_ = length;
	scoreTotal = _tmp79_ / _tmp80_;
	_tmp81_ = bTotal;
	_tmp82_ = length;
	bTotal = _tmp81_ / _tmp82_;
	_tmp83_ = gTotal;
	_tmp84_ = length;
	gTotal = _tmp83_ / _tmp84_;
	_tmp85_ = rTotal;
	_tmp86_ = length;
	rTotal = _tmp85_ / _tmp86_;
	_tmp87_ = scoreTotal;
	if (_tmp87_ > 0.0) {
		gdouble _tmp88_ = 0.0;
		gdouble _tmp89_ = 0.0;
		gdouble _tmp90_ = 0.0;
		gdouble _tmp91_ = 0.0;
		gdouble _tmp92_ = 0.0;
		gdouble _tmp93_ = 0.0;
		_tmp88_ = bTotal;
		_tmp89_ = scoreTotal;
		bTotal = _tmp88_ / _tmp89_;
		_tmp90_ = gTotal;
		_tmp91_ = scoreTotal;
		gTotal = _tmp90_ / _tmp91_;
		_tmp92_ = rTotal;
		_tmp93_ = scoreTotal;
		rTotal = _tmp92_ / _tmp93_;
	}
	_tmp94_ = bTotal2;
	_tmp95_ = length;
	_tmp96_ = G_MAXUINT8;
	bTotal2 = _tmp94_ / (_tmp95_ * _tmp96_);
	_tmp97_ = gTotal2;
	_tmp98_ = length;
	_tmp99_ = G_MAXUINT8;
	gTotal2 = _tmp97_ / (_tmp98_ * _tmp99_);
	_tmp100_ = rTotal2;
	_tmp101_ = length;
	_tmp102_ = G_MAXUINT8;
	rTotal2 = _tmp100_ / (_tmp101_ * _tmp102_);
	_tmp103_ = aTotal2;
	_tmp104_ = length;
	_tmp105_ = G_MAXUINT8;
	aTotal2 = _tmp103_ / (_tmp104_ * _tmp105_);
	_tmp106_ = scoreTotal;
	if (_tmp106_ <= PLANK_DRAWING_DRAWING_SERVICE_WEIGHT_THRESHOLD) {
		gdouble f = 0.0;
		gdouble _tmp107_ = 0.0;
		gdouble rf = 0.0;
		gdouble _tmp108_ = 0.0;
		gdouble _tmp109_ = 0.0;
		gdouble _tmp110_ = 0.0;
		gdouble _tmp111_ = 0.0;
		gdouble _tmp112_ = 0.0;
		gdouble _tmp113_ = 0.0;
		gdouble _tmp114_ = 0.0;
		gdouble _tmp115_ = 0.0;
		gdouble _tmp116_ = 0.0;
		gdouble _tmp117_ = 0.0;
		gdouble _tmp118_ = 0.0;
		gdouble _tmp119_ = 0.0;
		gdouble _tmp120_ = 0.0;
		_tmp107_ = scoreTotal;
		f = (1.0 / PLANK_DRAWING_DRAWING_SERVICE_WEIGHT_THRESHOLD) * _tmp107_;
		_tmp108_ = f;
		rf = 1.0 - _tmp108_;
		_tmp109_ = bTotal;
		_tmp110_ = f;
		_tmp111_ = bTotal2;
		_tmp112_ = rf;
		bTotal = (_tmp109_ * _tmp110_) + (_tmp111_ * _tmp112_);
		_tmp113_ = gTotal;
		_tmp114_ = f;
		_tmp115_ = gTotal2;
		_tmp116_ = rf;
		gTotal = (_tmp113_ * _tmp114_) + (_tmp115_ * _tmp116_);
		_tmp117_ = rTotal;
		_tmp118_ = f;
		_tmp119_ = rTotal2;
		_tmp120_ = rf;
		rTotal = (_tmp117_ * _tmp118_) + (_tmp119_ * _tmp120_);
	}
	_tmp121_ = rTotal;
	_tmp122_ = gTotal;
	_tmp123_ = bTotal;
	_tmp124_ = MAX (_tmp122_, _tmp123_);
	_tmp125_ = MAX (_tmp121_, _tmp124_);
	max_val = _tmp125_;
	_tmp126_ = max_val;
	if (_tmp126_ > 1.0) {
		gdouble _tmp127_ = 0.0;
		gdouble _tmp128_ = 0.0;
		gdouble _tmp129_ = 0.0;
		gdouble _tmp130_ = 0.0;
		gdouble _tmp131_ = 0.0;
		gdouble _tmp132_ = 0.0;
		_tmp127_ = bTotal;
		_tmp128_ = max_val;
		bTotal = _tmp127_ / _tmp128_;
		_tmp129_ = gTotal;
		_tmp130_ = max_val;
		gTotal = _tmp129_ / _tmp130_;
		_tmp131_ = rTotal;
		_tmp132_ = max_val;
		rTotal = _tmp131_ / _tmp132_;
	}
	_tmp133_ = rTotal;
	_tmp134_ = gTotal;
	_tmp135_ = bTotal;
	_tmp136_ = aTotal2;
	_tmp137_.red = _tmp133_;
	_tmp137_.green = _tmp134_;
	_tmp137_.blue = _tmp135_;
	_tmp137_.alpha = _tmp136_;
	*result = _tmp137_;
	return;
}


static void plank_drawing_drawing_service_class_init (PlankDrawingDrawingServiceClass * klass) {
	plank_drawing_drawing_service_parent_class = g_type_class_peek_parent (klass);
}


static void plank_drawing_drawing_service_instance_init (PlankDrawingDrawingService * self) {
}


/**
 * Utility service for loading icons and working with pixbufs.
 */
GType plank_drawing_drawing_service_get_type (void) {
	static volatile gsize plank_drawing_drawing_service_type_id__volatile = 0;
	if (g_once_init_enter (&plank_drawing_drawing_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankDrawingDrawingServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_drawing_drawing_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDrawingDrawingService), 0, (GInstanceInitFunc) plank_drawing_drawing_service_instance_init, NULL };
		GType plank_drawing_drawing_service_type_id;
		plank_drawing_drawing_service_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankDrawingDrawingService", &g_define_type_info, 0);
		g_once_init_leave (&plank_drawing_drawing_service_type_id__volatile, plank_drawing_drawing_service_type_id);
	}
	return plank_drawing_drawing_service_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



