/* WindowControl.c generated by valac 0.22.1, the Vala compiler
 * generated from WindowControl.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <libwnck/libwnck.h>
#include <libbamf/libbamf.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <gtk/gtk.h>
#include <string.h>


#define PLANK_SERVICES_WINDOWS_TYPE_STRUTS (plank_services_windows_struts_get_type ())

#define PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL (plank_services_windows_window_control_get_type ())
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL, PlankServicesWindowsWindowControl))
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL, PlankServicesWindowsWindowControlClass))
#define PLANK_SERVICES_WINDOWS_IS_WINDOW_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL))
#define PLANK_SERVICES_WINDOWS_IS_WINDOW_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL))
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL, PlankServicesWindowsWindowControlClass))

typedef struct _PlankServicesWindowsWindowControl PlankServicesWindowsWindowControl;
typedef struct _PlankServicesWindowsWindowControlClass PlankServicesWindowsWindowControlClass;
typedef struct _PlankServicesWindowsWindowControlPrivate PlankServicesWindowsWindowControlPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

typedef enum  {
	PLANK_SERVICES_WINDOWS_STRUTS_LEFT,
	PLANK_SERVICES_WINDOWS_STRUTS_RIGHT,
	PLANK_SERVICES_WINDOWS_STRUTS_TOP,
	PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM,
	PLANK_SERVICES_WINDOWS_STRUTS_LEFT_START,
	PLANK_SERVICES_WINDOWS_STRUTS_LEFT_END,
	PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_START,
	PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_END,
	PLANK_SERVICES_WINDOWS_STRUTS_TOP_START,
	PLANK_SERVICES_WINDOWS_STRUTS_TOP_END,
	PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_START,
	PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_END,
	PLANK_SERVICES_WINDOWS_STRUTS_N_VALUES
} PlankServicesWindowsStruts;

struct _PlankServicesWindowsWindowControl {
	GObject parent_instance;
	PlankServicesWindowsWindowControlPrivate * priv;
};

struct _PlankServicesWindowsWindowControlClass {
	GObjectClass parent_class;
};


static gpointer plank_services_windows_window_control_parent_class = NULL;
static guint plank_services_windows_window_control_delayed_focus_timer;
static guint plank_services_windows_window_control_delayed_focus_timer = (guint) 0;
static WnckWindow* plank_services_windows_window_control_delayed_focus_window;
static WnckWindow* plank_services_windows_window_control_delayed_focus_window = NULL;

GType plank_services_windows_struts_get_type (void) G_GNUC_CONST;
GType plank_services_windows_window_control_get_type (void) G_GNUC_CONST;
enum  {
	PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_DUMMY_PROPERTY
};
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY ((guint) 10000)
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY ((guint) 200)
static PlankServicesWindowsWindowControl* plank_services_windows_window_control_new (void);
static PlankServicesWindowsWindowControl* plank_services_windows_window_control_construct (GType object_type);
void plank_services_windows_window_control_initialize (void);
static void plank_services_windows_window_control_window_manager_changed (WnckScreen* screen);
static void _plank_services_windows_window_control_window_manager_changed_wnck_screen_window_manager_changed (WnckScreen* _sender, gpointer self);
static void plank_services_windows_window_control_handle_window_closed (WnckWindow* window);
static void _plank_services_windows_window_control_handle_window_closed_wnck_screen_window_closed (WnckScreen* _sender, WnckWindow* window, gpointer self);
GdkPixbuf* plank_services_windows_window_control_get_app_icon (BamfApplication* app);
GdkPixbuf* plank_services_windows_window_control_get_window_icon (BamfWindow* window);
guint plank_services_windows_window_control_get_num_windows (BamfApplication* app);
gboolean plank_services_windows_window_control_has_maximized_window (BamfApplication* app);
gboolean plank_services_windows_window_control_has_minimized_window (BamfApplication* app);
gboolean plank_services_windows_window_control_has_window_on_workspace (BamfApplication* app, WnckWorkspace* workspace);
void plank_services_windows_window_control_update_icon_regions (BamfApplication* app, GdkRectangle* rect);
void plank_services_windows_window_control_close_all (BamfApplication* app);
void plank_services_windows_window_control_focus_window (BamfWindow* window);
static void plank_services_windows_window_control_center_and_focus_window (WnckWindow* w);
static void plank_services_windows_window_control_focus_window_by_xid (guint32 xid);
static gint plank_services_windows_window_control_find_active_xid_index (GArray* xids);
void plank_services_windows_window_control_focus_previous (BamfApplication* app);
void plank_services_windows_window_control_focus_next (BamfApplication* app);
void plank_services_windows_window_control_minimize (BamfApplication* app);
GList* plank_services_windows_window_control_get_ordered_window_stack (BamfApplication* app);
void plank_services_windows_window_control_restore (BamfApplication* app);
void plank_services_windows_window_control_maximize (BamfApplication* app);
void plank_services_windows_window_control_unmaximize (BamfApplication* app);
void plank_services_windows_window_control_smart_focus (BamfApplication* app);
static void plank_services_windows_window_control_intelligent_focus_off_viewport_window (WnckWindow* targetWindow, GList* additional_windows);
static gboolean plank_services_windows_window_control_windows_share_viewport (WnckWindow* first, WnckWindow* second);
static gboolean __lambda2_ (void);
static gboolean ___lambda2__gsource_func (gpointer self);
void plank_services_windows_window_control_get_easy_geometry (WnckWindow* w, GdkRectangle* result);
static void plank_services_windows_window_control_finalize (GObject* obj);


GType plank_services_windows_struts_get_type (void) {
	static volatile gsize plank_services_windows_struts_type_id__volatile = 0;
	if (g_once_init_enter (&plank_services_windows_struts_type_id__volatile)) {
		static const GEnumValue values[] = {{PLANK_SERVICES_WINDOWS_STRUTS_LEFT, "PLANK_SERVICES_WINDOWS_STRUTS_LEFT", "left"}, {PLANK_SERVICES_WINDOWS_STRUTS_RIGHT, "PLANK_SERVICES_WINDOWS_STRUTS_RIGHT", "right"}, {PLANK_SERVICES_WINDOWS_STRUTS_TOP, "PLANK_SERVICES_WINDOWS_STRUTS_TOP", "top"}, {PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM, "PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM", "bottom"}, {PLANK_SERVICES_WINDOWS_STRUTS_LEFT_START, "PLANK_SERVICES_WINDOWS_STRUTS_LEFT_START", "left-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_LEFT_END, "PLANK_SERVICES_WINDOWS_STRUTS_LEFT_END", "left-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_START, "PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_START", "right-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_END, "PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_END", "right-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_TOP_START, "PLANK_SERVICES_WINDOWS_STRUTS_TOP_START", "top-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_TOP_END, "PLANK_SERVICES_WINDOWS_STRUTS_TOP_END", "top-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_START, "PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_START", "bottom-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_END, "PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_END", "bottom-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_N_VALUES, "PLANK_SERVICES_WINDOWS_STRUTS_N_VALUES", "n-values"}, {0, NULL, NULL}};
		GType plank_services_windows_struts_type_id;
		plank_services_windows_struts_type_id = g_enum_register_static ("PlankServicesWindowsStruts", values);
		g_once_init_leave (&plank_services_windows_struts_type_id__volatile, plank_services_windows_struts_type_id);
	}
	return plank_services_windows_struts_type_id__volatile;
}


static PlankServicesWindowsWindowControl* plank_services_windows_window_control_construct (GType object_type) {
	PlankServicesWindowsWindowControl * self = NULL;
	self = (PlankServicesWindowsWindowControl*) g_object_new (object_type, NULL);
	return self;
}


static PlankServicesWindowsWindowControl* plank_services_windows_window_control_new (void) {
	return plank_services_windows_window_control_construct (PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL);
}


static void _plank_services_windows_window_control_window_manager_changed_wnck_screen_window_manager_changed (WnckScreen* _sender, gpointer self) {
	plank_services_windows_window_control_window_manager_changed (_sender);
}


static void _plank_services_windows_window_control_handle_window_closed_wnck_screen_window_closed (WnckScreen* _sender, WnckWindow* window, gpointer self) {
	plank_services_windows_window_control_handle_window_closed (window);
}


void plank_services_windows_window_control_initialize (void) {
	WnckScreen* screen = NULL;
	WnckScreen* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	_tmp0_ = wnck_screen_get_default ();
	screen = _tmp0_;
	wnck_set_client_type (WNCK_CLIENT_TYPE_PAGER);
	wnck_screen_force_update (screen);
	g_signal_connect_after (screen, "window-manager-changed", (GCallback) _plank_services_windows_window_control_window_manager_changed_wnck_screen_window_manager_changed, NULL);
	g_signal_connect_after (screen, "window-closed", (GCallback) _plank_services_windows_window_control_handle_window_closed_wnck_screen_window_closed, NULL);
	_tmp1_ = wnck_screen_get_window_manager_name (screen);
	g_message ("WindowControl.vala:62: Window-manager: %s", _tmp1_);
}


static void plank_services_windows_window_control_window_manager_changed (WnckScreen* screen) {
	WnckScreen* _tmp0_ = NULL;
	WnckScreen* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	g_return_if_fail (screen != NULL);
	_tmp0_ = screen;
	wnck_screen_force_update (_tmp0_);
	_tmp1_ = screen;
	_tmp2_ = wnck_screen_get_window_manager_name (_tmp1_);
	g_warning ("WindowControl.vala:70: Window-manager changed: %s", _tmp2_);
}


static void plank_services_windows_window_control_handle_window_closed (WnckWindow* window) {
	gboolean _tmp0_ = FALSE;
	guint _tmp1_ = 0U;
	gboolean _tmp4_ = FALSE;
	g_return_if_fail (window != NULL);
	_tmp1_ = plank_services_windows_window_control_delayed_focus_timer;
	if (_tmp1_ > ((guint) 0)) {
		WnckWindow* _tmp2_ = NULL;
		WnckWindow* _tmp3_ = NULL;
		_tmp2_ = plank_services_windows_window_control_delayed_focus_window;
		_tmp3_ = window;
		_tmp0_ = _tmp2_ == _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp4_ = _tmp0_;
	if (_tmp4_) {
		guint _tmp5_ = 0U;
		_tmp5_ = plank_services_windows_window_control_delayed_focus_timer;
		g_source_remove (_tmp5_);
		plank_services_windows_window_control_delayed_focus_timer = (guint) 0;
		_g_object_unref0 (plank_services_windows_window_control_delayed_focus_window);
		plank_services_windows_window_control_delayed_focus_window = NULL;
	}
}


GdkPixbuf* plank_services_windows_window_control_get_app_icon (BamfApplication* app) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GdkPixbuf* _tmp22_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	pbuf = NULL;
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				GArray* _tmp8_ = NULL;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp14_ = FALSE;
				WnckWindow* window = NULL;
				GArray* _tmp15_ = NULL;
				gint _tmp16_ = 0;
				guint32 _tmp17_ = 0U;
				WnckWindow* _tmp18_ = NULL;
				WnckWindow* _tmp19_ = NULL;
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					gint _tmp5_ = 0;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp8_ = xids;
				if (_tmp8_ != NULL) {
					gint _tmp9_ = 0;
					GArray* _tmp10_ = NULL;
					guint _tmp11_ = 0U;
					_tmp9_ = i;
					_tmp10_ = xids;
					_tmp11_ = _tmp10_->len;
					_tmp7_ = ((guint) _tmp9_) < _tmp11_;
				} else {
					_tmp7_ = FALSE;
				}
				_tmp12_ = _tmp7_;
				if (_tmp12_) {
					GdkPixbuf* _tmp13_ = NULL;
					_tmp13_ = pbuf;
					_tmp6_ = _tmp13_ == NULL;
				} else {
					_tmp6_ = FALSE;
				}
				_tmp14_ = _tmp6_;
				if (!_tmp14_) {
					break;
				}
				_tmp15_ = xids;
				_tmp16_ = i;
				_tmp17_ = g_array_index (_tmp15_, guint32, (guint) _tmp16_);
				_tmp18_ = wnck_window_get ((gulong) _tmp17_);
				window = _tmp18_;
				_tmp19_ = window;
				if (_tmp19_ != NULL) {
					WnckWindow* _tmp20_ = NULL;
					GdkPixbuf* _tmp21_ = NULL;
					_tmp20_ = window;
					_tmp21_ = wnck_window_get_icon (_tmp20_);
					pbuf = _tmp21_;
				}
			}
		}
	}
	_tmp22_ = pbuf;
	result = _tmp22_;
	_g_array_unref0 (xids);
	return result;
}


GdkPixbuf* plank_services_windows_window_control_get_window_icon (BamfWindow* window) {
	GdkPixbuf* result = NULL;
	WnckWindow* w = NULL;
	BamfWindow* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	WnckWindow* _tmp2_ = NULL;
	WnckWindow* _tmp3_ = NULL;
	WnckWindow* _tmp4_ = NULL;
	WnckWindow* _tmp5_ = NULL;
	GdkPixbuf* _tmp6_ = NULL;
	g_return_val_if_fail (window != NULL, NULL);
	_tmp0_ = window;
	_tmp1_ = bamf_window_get_xid (_tmp0_);
	_tmp2_ = wnck_window_get ((gulong) _tmp1_);
	w = _tmp2_;
	_tmp3_ = w;
	g_warn_if_fail (_tmp3_ != NULL);
	_tmp4_ = w;
	if (_tmp4_ == NULL) {
		result = NULL;
		return result;
	}
	_tmp5_ = w;
	_tmp6_ = wnck_window_get_icon (_tmp5_);
	result = _tmp6_;
	return result;
}


guint plank_services_windows_window_control_get_num_windows (BamfApplication* app) {
	guint result = 0U;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	guint count = 0U;
	g_return_val_if_fail (app != NULL, 0U);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	count = (guint) 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_ = NULL;
				gboolean _tmp11_ = FALSE;
				WnckWindow* window = NULL;
				GArray* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				gboolean _tmp16_ = FALSE;
				WnckWindow* _tmp17_ = NULL;
				gboolean _tmp20_ = FALSE;
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					gint _tmp5_ = 0;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp7_ = xids;
				if (_tmp7_ != NULL) {
					gint _tmp8_ = 0;
					GArray* _tmp9_ = NULL;
					guint _tmp10_ = 0U;
					_tmp8_ = i;
					_tmp9_ = xids;
					_tmp10_ = _tmp9_->len;
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
				} else {
					_tmp6_ = FALSE;
				}
				_tmp11_ = _tmp6_;
				if (!_tmp11_) {
					break;
				}
				_tmp12_ = xids;
				_tmp13_ = i;
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
				window = _tmp15_;
				_tmp17_ = window;
				if (_tmp17_ != NULL) {
					WnckWindow* _tmp18_ = NULL;
					WnckWindow* _tmp19_ = NULL;
					_tmp18_ = window;
					_tmp19_ = wnck_window_get_transient (_tmp18_);
					_tmp16_ = _tmp19_ == NULL;
				} else {
					_tmp16_ = FALSE;
				}
				_tmp20_ = _tmp16_;
				if (_tmp20_) {
					guint _tmp21_ = 0U;
					_tmp21_ = count;
					count = _tmp21_ + 1;
				}
			}
		}
	}
	result = count;
	_g_array_unref0 (xids);
	return result;
}


gboolean plank_services_windows_window_control_has_maximized_window (BamfApplication* app) {
	gboolean result = FALSE;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_val_if_fail (app != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_ = NULL;
				gboolean _tmp11_ = FALSE;
				WnckWindow* window = NULL;
				GArray* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				gboolean _tmp16_ = FALSE;
				WnckWindow* _tmp17_ = NULL;
				gboolean _tmp20_ = FALSE;
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					gint _tmp5_ = 0;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp7_ = xids;
				if (_tmp7_ != NULL) {
					gint _tmp8_ = 0;
					GArray* _tmp9_ = NULL;
					guint _tmp10_ = 0U;
					_tmp8_ = i;
					_tmp9_ = xids;
					_tmp10_ = _tmp9_->len;
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
				} else {
					_tmp6_ = FALSE;
				}
				_tmp11_ = _tmp6_;
				if (!_tmp11_) {
					break;
				}
				_tmp12_ = xids;
				_tmp13_ = i;
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
				window = _tmp15_;
				_tmp17_ = window;
				if (_tmp17_ != NULL) {
					WnckWindow* _tmp18_ = NULL;
					gboolean _tmp19_ = FALSE;
					_tmp18_ = window;
					_tmp19_ = wnck_window_is_maximized (_tmp18_);
					_tmp16_ = _tmp19_;
				} else {
					_tmp16_ = FALSE;
				}
				_tmp20_ = _tmp16_;
				if (_tmp20_) {
					result = TRUE;
					_g_array_unref0 (xids);
					return result;
				}
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


gboolean plank_services_windows_window_control_has_minimized_window (BamfApplication* app) {
	gboolean result = FALSE;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_val_if_fail (app != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_ = NULL;
				gboolean _tmp11_ = FALSE;
				WnckWindow* window = NULL;
				GArray* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				gboolean _tmp16_ = FALSE;
				WnckWindow* _tmp17_ = NULL;
				gboolean _tmp20_ = FALSE;
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					gint _tmp5_ = 0;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp7_ = xids;
				if (_tmp7_ != NULL) {
					gint _tmp8_ = 0;
					GArray* _tmp9_ = NULL;
					guint _tmp10_ = 0U;
					_tmp8_ = i;
					_tmp9_ = xids;
					_tmp10_ = _tmp9_->len;
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
				} else {
					_tmp6_ = FALSE;
				}
				_tmp11_ = _tmp6_;
				if (!_tmp11_) {
					break;
				}
				_tmp12_ = xids;
				_tmp13_ = i;
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
				window = _tmp15_;
				_tmp17_ = window;
				if (_tmp17_ != NULL) {
					WnckWindow* _tmp18_ = NULL;
					gboolean _tmp19_ = FALSE;
					_tmp18_ = window;
					_tmp19_ = wnck_window_is_minimized (_tmp18_);
					_tmp16_ = _tmp19_;
				} else {
					_tmp16_ = FALSE;
				}
				_tmp20_ = _tmp16_;
				if (_tmp20_) {
					result = TRUE;
					_g_array_unref0 (xids);
					return result;
				}
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


gboolean plank_services_windows_window_control_has_window_on_workspace (BamfApplication* app, WnckWorkspace* workspace) {
	gboolean result = FALSE;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	gboolean is_virtual = FALSE;
	WnckWorkspace* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	g_return_val_if_fail (app != NULL, FALSE);
	g_return_val_if_fail (workspace != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = workspace;
	_tmp4_ = wnck_workspace_is_virtual (_tmp3_);
	is_virtual = _tmp4_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp8_ = FALSE;
				GArray* _tmp9_ = NULL;
				gboolean _tmp13_ = FALSE;
				WnckWindow* window = NULL;
				GArray* _tmp14_ = NULL;
				gint _tmp15_ = 0;
				guint32 _tmp16_ = 0U;
				WnckWindow* _tmp17_ = NULL;
				WnckWindow* _tmp18_ = NULL;
				gboolean _tmp19_ = FALSE;
				_tmp6_ = _tmp5_;
				if (!_tmp6_) {
					gint _tmp7_ = 0;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp9_ = xids;
				if (_tmp9_ != NULL) {
					gint _tmp10_ = 0;
					GArray* _tmp11_ = NULL;
					guint _tmp12_ = 0U;
					_tmp10_ = i;
					_tmp11_ = xids;
					_tmp12_ = _tmp11_->len;
					_tmp8_ = ((guint) _tmp10_) < _tmp12_;
				} else {
					_tmp8_ = FALSE;
				}
				_tmp13_ = _tmp8_;
				if (!_tmp13_) {
					break;
				}
				_tmp14_ = xids;
				_tmp15_ = i;
				_tmp16_ = g_array_index (_tmp14_, guint32, (guint) _tmp15_);
				_tmp17_ = wnck_window_get ((gulong) _tmp16_);
				window = _tmp17_;
				_tmp18_ = window;
				if (_tmp18_ == NULL) {
					continue;
				}
				_tmp19_ = is_virtual;
				if (!_tmp19_) {
					WnckWindow* _tmp20_ = NULL;
					WnckWorkspace* _tmp21_ = NULL;
					gboolean _tmp22_ = FALSE;
					_tmp20_ = window;
					_tmp21_ = workspace;
					_tmp22_ = wnck_window_is_on_workspace (_tmp20_, _tmp21_);
					if (_tmp22_) {
						result = TRUE;
						_g_array_unref0 (xids);
						return result;
					}
				} else {
					WnckWindow* _tmp23_ = NULL;
					WnckWorkspace* _tmp24_ = NULL;
					gboolean _tmp25_ = FALSE;
					_tmp23_ = window;
					_tmp24_ = workspace;
					_tmp25_ = wnck_window_is_in_viewport (_tmp23_, _tmp24_);
					if (_tmp25_) {
						result = TRUE;
						_g_array_unref0 (xids);
						return result;
					}
				}
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


void plank_services_windows_window_control_update_icon_regions (BamfApplication* app, GdkRectangle* rect) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_if_fail (app != NULL);
	g_return_if_fail (rect != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_ = NULL;
				gboolean _tmp11_ = FALSE;
				WnckWindow* window = NULL;
				GArray* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				WnckWindow* _tmp16_ = NULL;
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					gint _tmp5_ = 0;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp7_ = xids;
				if (_tmp7_ != NULL) {
					gint _tmp8_ = 0;
					GArray* _tmp9_ = NULL;
					guint _tmp10_ = 0U;
					_tmp8_ = i;
					_tmp9_ = xids;
					_tmp10_ = _tmp9_->len;
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
				} else {
					_tmp6_ = FALSE;
				}
				_tmp11_ = _tmp6_;
				if (!_tmp11_) {
					break;
				}
				_tmp12_ = xids;
				_tmp13_ = i;
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
				window = _tmp15_;
				_tmp16_ = window;
				if (_tmp16_ != NULL) {
					WnckWindow* _tmp17_ = NULL;
					GdkRectangle _tmp18_ = {0};
					gint _tmp19_ = 0;
					GdkRectangle _tmp20_ = {0};
					gint _tmp21_ = 0;
					GdkRectangle _tmp22_ = {0};
					gint _tmp23_ = 0;
					GdkRectangle _tmp24_ = {0};
					gint _tmp25_ = 0;
					_tmp17_ = window;
					_tmp18_ = *rect;
					_tmp19_ = _tmp18_.x;
					_tmp20_ = *rect;
					_tmp21_ = _tmp20_.y;
					_tmp22_ = *rect;
					_tmp23_ = _tmp22_.width;
					_tmp24_ = *rect;
					_tmp25_ = _tmp24_.height;
					wnck_window_set_icon_geometry (_tmp17_, _tmp19_, _tmp21_, _tmp23_, _tmp25_);
				}
			}
		}
	}
	_g_array_unref0 (xids);
}


void plank_services_windows_window_control_close_all (BamfApplication* app) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_ = NULL;
				gboolean _tmp11_ = FALSE;
				WnckWindow* window = NULL;
				GArray* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				gboolean _tmp16_ = FALSE;
				WnckWindow* _tmp17_ = NULL;
				gboolean _tmp20_ = FALSE;
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					gint _tmp5_ = 0;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp7_ = xids;
				if (_tmp7_ != NULL) {
					gint _tmp8_ = 0;
					GArray* _tmp9_ = NULL;
					guint _tmp10_ = 0U;
					_tmp8_ = i;
					_tmp9_ = xids;
					_tmp10_ = _tmp9_->len;
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
				} else {
					_tmp6_ = FALSE;
				}
				_tmp11_ = _tmp6_;
				if (!_tmp11_) {
					break;
				}
				_tmp12_ = xids;
				_tmp13_ = i;
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
				window = _tmp15_;
				_tmp17_ = window;
				if (_tmp17_ != NULL) {
					WnckWindow* _tmp18_ = NULL;
					gboolean _tmp19_ = FALSE;
					_tmp18_ = window;
					_tmp19_ = wnck_window_is_skip_tasklist (_tmp18_);
					_tmp16_ = !_tmp19_;
				} else {
					_tmp16_ = FALSE;
				}
				_tmp20_ = _tmp16_;
				if (_tmp20_) {
					WnckWindow* _tmp21_ = NULL;
					guint32 _tmp22_ = 0U;
					_tmp21_ = window;
					_tmp22_ = gtk_get_current_event_time ();
					wnck_window_close (_tmp21_, _tmp22_);
				}
			}
		}
	}
	_g_array_unref0 (xids);
}


void plank_services_windows_window_control_focus_window (BamfWindow* window) {
	WnckWindow* w = NULL;
	BamfWindow* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	WnckWindow* _tmp2_ = NULL;
	WnckWindow* _tmp3_ = NULL;
	WnckWindow* _tmp4_ = NULL;
	WnckWindow* _tmp5_ = NULL;
	g_return_if_fail (window != NULL);
	wnck_screen_get_default ();
	_tmp0_ = window;
	_tmp1_ = bamf_window_get_xid (_tmp0_);
	_tmp2_ = wnck_window_get ((gulong) _tmp1_);
	w = _tmp2_;
	_tmp3_ = w;
	g_warn_if_fail (_tmp3_ != NULL);
	_tmp4_ = w;
	if (_tmp4_ == NULL) {
		return;
	}
	_tmp5_ = w;
	plank_services_windows_window_control_center_and_focus_window (_tmp5_);
}


static void plank_services_windows_window_control_focus_window_by_xid (guint32 xid) {
	WnckWindow* w = NULL;
	guint32 _tmp0_ = 0U;
	WnckWindow* _tmp1_ = NULL;
	WnckWindow* _tmp2_ = NULL;
	WnckWindow* _tmp3_ = NULL;
	WnckWindow* _tmp4_ = NULL;
	wnck_screen_get_default ();
	_tmp0_ = xid;
	_tmp1_ = wnck_window_get ((gulong) _tmp0_);
	w = _tmp1_;
	_tmp2_ = w;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = w;
	if (_tmp3_ == NULL) {
		return;
	}
	_tmp4_ = w;
	plank_services_windows_window_control_center_and_focus_window (_tmp4_);
}


static gint plank_services_windows_window_control_find_active_xid_index (GArray* xids) {
	gint result = 0;
	gint i = 0;
	i = 0;
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			gboolean _tmp1_ = FALSE;
			gboolean _tmp3_ = FALSE;
			GArray* _tmp4_ = NULL;
			gboolean _tmp8_ = FALSE;
			WnckWindow* window = NULL;
			GArray* _tmp9_ = NULL;
			gint _tmp10_ = 0;
			guint32 _tmp11_ = 0U;
			WnckWindow* _tmp12_ = NULL;
			gboolean _tmp13_ = FALSE;
			WnckWindow* _tmp14_ = NULL;
			gboolean _tmp17_ = FALSE;
			_tmp1_ = _tmp0_;
			if (!_tmp1_) {
				gint _tmp2_ = 0;
				_tmp2_ = i;
				i = _tmp2_ + 1;
			}
			_tmp0_ = FALSE;
			_tmp4_ = xids;
			if (_tmp4_ != NULL) {
				gint _tmp5_ = 0;
				GArray* _tmp6_ = NULL;
				guint _tmp7_ = 0U;
				_tmp5_ = i;
				_tmp6_ = xids;
				_tmp7_ = _tmp6_->len;
				_tmp3_ = ((guint) _tmp5_) < _tmp7_;
			} else {
				_tmp3_ = FALSE;
			}
			_tmp8_ = _tmp3_;
			if (!_tmp8_) {
				break;
			}
			_tmp9_ = xids;
			_tmp10_ = i;
			_tmp11_ = g_array_index (_tmp9_, guint32, (guint) _tmp10_);
			_tmp12_ = wnck_window_get ((gulong) _tmp11_);
			window = _tmp12_;
			_tmp14_ = window;
			if (_tmp14_ != NULL) {
				WnckWindow* _tmp15_ = NULL;
				gboolean _tmp16_ = FALSE;
				_tmp15_ = window;
				_tmp16_ = wnck_window_is_active (_tmp15_);
				_tmp13_ = _tmp16_;
			} else {
				_tmp13_ = FALSE;
			}
			_tmp17_ = _tmp13_;
			if (_tmp17_) {
				break;
			}
		}
	}
	result = i;
	return result;
}


void plank_services_windows_window_control_focus_previous (BamfApplication* app) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GArray* _tmp3_ = NULL;
	gint i = 0;
	GArray* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	GArray* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	GArray* _tmp15_ = NULL;
	gint _tmp16_ = 0;
	guint32 _tmp17_ = 0U;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = xids;
	if (_tmp3_ == NULL) {
		_g_array_unref0 (xids);
		return;
	}
	_tmp4_ = xids;
	_tmp5_ = plank_services_windows_window_control_find_active_xid_index (_tmp4_);
	i = _tmp5_;
	_tmp7_ = i;
	_tmp8_ = xids;
	_tmp9_ = _tmp8_->len;
	if (((guint) _tmp7_) < _tmp9_) {
		gint _tmp10_ = 0;
		_tmp10_ = i;
		_tmp6_ = _tmp10_ - 1;
	} else {
		_tmp6_ = 0;
	}
	_tmp11_ = _tmp6_;
	i = _tmp11_;
	_tmp12_ = i;
	if (_tmp12_ < 0) {
		GArray* _tmp13_ = NULL;
		guint _tmp14_ = 0U;
		_tmp13_ = xids;
		_tmp14_ = _tmp13_->len;
		i = ((gint) _tmp14_) - 1;
	}
	_tmp15_ = xids;
	_tmp16_ = i;
	_tmp17_ = g_array_index (_tmp15_, guint32, (guint) _tmp16_);
	plank_services_windows_window_control_focus_window_by_xid (_tmp17_);
	_g_array_unref0 (xids);
}


void plank_services_windows_window_control_focus_next (BamfApplication* app) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GArray* _tmp3_ = NULL;
	gint i = 0;
	GArray* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	GArray* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	GArray* _tmp13_ = NULL;
	guint _tmp14_ = 0U;
	GArray* _tmp15_ = NULL;
	gint _tmp16_ = 0;
	guint32 _tmp17_ = 0U;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = xids;
	if (_tmp3_ == NULL) {
		_g_array_unref0 (xids);
		return;
	}
	_tmp4_ = xids;
	_tmp5_ = plank_services_windows_window_control_find_active_xid_index (_tmp4_);
	i = _tmp5_;
	_tmp7_ = i;
	_tmp8_ = xids;
	_tmp9_ = _tmp8_->len;
	if (((guint) _tmp7_) < _tmp9_) {
		gint _tmp10_ = 0;
		_tmp10_ = i;
		_tmp6_ = _tmp10_ + 1;
	} else {
		_tmp6_ = 0;
	}
	_tmp11_ = _tmp6_;
	i = _tmp11_;
	_tmp12_ = i;
	_tmp13_ = xids;
	_tmp14_ = _tmp13_->len;
	if (((guint) _tmp12_) == _tmp14_) {
		i = 0;
	}
	_tmp15_ = xids;
	_tmp16_ = i;
	_tmp17_ = g_array_index (_tmp15_, guint32, (guint) _tmp16_);
	plank_services_windows_window_control_focus_window_by_xid (_tmp17_);
	_g_array_unref0 (xids);
}


void plank_services_windows_window_control_minimize (BamfApplication* app) {
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp1_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp2_ = FALSE;
				WnckWindow* _tmp3_ = NULL;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp10_ = FALSE;
				_tmp3_ = window;
				_tmp4_ = wnck_window_is_minimized (_tmp3_);
				if (!_tmp4_) {
					WnckWindow* _tmp5_ = NULL;
					WnckWindow* _tmp6_ = NULL;
					WnckScreen* _tmp7_ = NULL;
					WnckWorkspace* _tmp8_ = NULL;
					gboolean _tmp9_ = FALSE;
					_tmp5_ = window;
					_tmp6_ = window;
					_tmp7_ = wnck_window_get_screen (_tmp6_);
					_tmp8_ = wnck_screen_get_active_workspace (_tmp7_);
					_tmp9_ = wnck_window_is_in_viewport (_tmp5_, _tmp8_);
					_tmp2_ = _tmp9_;
				} else {
					_tmp2_ = FALSE;
				}
				_tmp10_ = _tmp2_;
				if (_tmp10_) {
					WnckWindow* _tmp11_ = NULL;
					_tmp11_ = window;
					wnck_window_minimize (_tmp11_);
					g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
				}
			}
		}
		_g_list_free0 (window_collection);
	}
}


void plank_services_windows_window_control_restore (BamfApplication* app) {
	GList* stack = NULL;
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	GList* _tmp2_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
	stack = _tmp1_;
	stack = g_list_reverse (stack);
	_tmp2_ = stack;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp2_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp3_ = FALSE;
				WnckWindow* _tmp4_ = NULL;
				gboolean _tmp5_ = FALSE;
				gboolean _tmp11_ = FALSE;
				_tmp4_ = window;
				_tmp5_ = wnck_window_is_minimized (_tmp4_);
				if (_tmp5_) {
					WnckWindow* _tmp6_ = NULL;
					WnckWindow* _tmp7_ = NULL;
					WnckScreen* _tmp8_ = NULL;
					WnckWorkspace* _tmp9_ = NULL;
					gboolean _tmp10_ = FALSE;
					_tmp6_ = window;
					_tmp7_ = window;
					_tmp8_ = wnck_window_get_screen (_tmp7_);
					_tmp9_ = wnck_screen_get_active_workspace (_tmp8_);
					_tmp10_ = wnck_window_is_in_viewport (_tmp6_, _tmp9_);
					_tmp3_ = _tmp10_;
				} else {
					_tmp3_ = FALSE;
				}
				_tmp11_ = _tmp3_;
				if (_tmp11_) {
					WnckWindow* _tmp12_ = NULL;
					guint32 _tmp13_ = 0U;
					_tmp12_ = window;
					_tmp13_ = gtk_get_current_event_time ();
					wnck_window_unminimize (_tmp12_, _tmp13_);
					g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
				}
			}
		}
	}
	_g_list_free0 (stack);
}


void plank_services_windows_window_control_maximize (BamfApplication* app) {
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp1_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWindow* _tmp2_ = NULL;
				gboolean _tmp3_ = FALSE;
				_tmp2_ = window;
				_tmp3_ = wnck_window_is_maximized (_tmp2_);
				if (!_tmp3_) {
					WnckWindow* _tmp4_ = NULL;
					_tmp4_ = window;
					wnck_window_maximize (_tmp4_);
				}
			}
		}
		_g_list_free0 (window_collection);
	}
}


void plank_services_windows_window_control_unmaximize (BamfApplication* app) {
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp1_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWindow* _tmp2_ = NULL;
				gboolean _tmp3_ = FALSE;
				_tmp2_ = window;
				_tmp3_ = wnck_window_is_maximized (_tmp2_);
				if (_tmp3_) {
					WnckWindow* _tmp4_ = NULL;
					_tmp4_ = window;
					wnck_window_unmaximize (_tmp4_);
				}
			}
		}
		_g_list_free0 (window_collection);
	}
}


GList* plank_services_windows_window_control_get_ordered_window_stack (BamfApplication* app) {
	GList* result = NULL;
	GList* windows = NULL;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GArray* _tmp3_ = NULL;
	GList* stack = NULL;
	WnckScreen* _tmp4_ = NULL;
	GList* _tmp5_ = NULL;
	GList* _tmp6_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	windows = NULL;
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = xids;
	if (_tmp3_ == NULL) {
		result = windows;
		_g_array_unref0 (xids);
		return result;
	}
	_tmp4_ = wnck_screen_get_default ();
	_tmp5_ = wnck_screen_get_windows_stacked (_tmp4_);
	stack = _tmp5_;
	_tmp6_ = stack;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp6_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp7_ = FALSE;
						_tmp7_ = TRUE;
						while (TRUE) {
							gboolean _tmp8_ = FALSE;
							gint _tmp10_ = 0;
							GArray* _tmp11_ = NULL;
							guint _tmp12_ = 0U;
							GArray* _tmp13_ = NULL;
							gint _tmp14_ = 0;
							guint32 _tmp15_ = 0U;
							WnckWindow* _tmp16_ = NULL;
							gulong _tmp17_ = 0UL;
							_tmp8_ = _tmp7_;
							if (!_tmp8_) {
								gint _tmp9_ = 0;
								_tmp9_ = j;
								j = _tmp9_ + 1;
							}
							_tmp7_ = FALSE;
							_tmp10_ = j;
							_tmp11_ = xids;
							_tmp12_ = _tmp11_->len;
							if (!(((guint) _tmp10_) < _tmp12_)) {
								break;
							}
							_tmp13_ = xids;
							_tmp14_ = j;
							_tmp15_ = g_array_index (_tmp13_, guint32, (guint) _tmp14_);
							_tmp16_ = window;
							_tmp17_ = wnck_window_get_xid (_tmp16_);
							if (((gulong) _tmp15_) == _tmp17_) {
								WnckWindow* _tmp18_ = NULL;
								_tmp18_ = window;
								windows = g_list_append (windows, _tmp18_);
							}
						}
					}
				}
			}
		}
	}
	result = windows;
	_g_array_unref0 (xids);
	return result;
}


void plank_services_windows_window_control_smart_focus (BamfApplication* app) {
	GList* windows = NULL;
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	gboolean not_in_viewport = FALSE;
	gboolean urgent = FALSE;
	GList* _tmp2_ = NULL;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp17_ = FALSE;
	GList* _tmp28_ = NULL;
	GList* _tmp50_ = NULL;
	GList* _tmp76_ = NULL;
	GList* _tmp89_ = NULL;
	gconstpointer _tmp90_ = NULL;
	GList* _tmp91_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
	windows = _tmp1_;
	not_in_viewport = TRUE;
	urgent = FALSE;
	_tmp2_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp2_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp3_ = FALSE;
				WnckWindow* _tmp4_ = NULL;
				gboolean _tmp5_ = FALSE;
				gboolean _tmp11_ = FALSE;
				WnckWindow* _tmp12_ = NULL;
				gboolean _tmp13_ = FALSE;
				_tmp4_ = window;
				_tmp5_ = wnck_window_is_skip_tasklist (_tmp4_);
				if (!_tmp5_) {
					WnckWindow* _tmp6_ = NULL;
					WnckWindow* _tmp7_ = NULL;
					WnckScreen* _tmp8_ = NULL;
					WnckWorkspace* _tmp9_ = NULL;
					gboolean _tmp10_ = FALSE;
					_tmp6_ = window;
					_tmp7_ = window;
					_tmp8_ = wnck_window_get_screen (_tmp7_);
					_tmp9_ = wnck_screen_get_active_workspace (_tmp8_);
					_tmp10_ = wnck_window_is_in_viewport (_tmp6_, _tmp9_);
					_tmp3_ = _tmp10_;
				} else {
					_tmp3_ = FALSE;
				}
				_tmp11_ = _tmp3_;
				if (_tmp11_) {
					not_in_viewport = FALSE;
				}
				_tmp12_ = window;
				_tmp13_ = wnck_window_needs_attention (_tmp12_);
				if (_tmp13_) {
					urgent = TRUE;
				}
			}
		}
	}
	_tmp15_ = not_in_viewport;
	if (_tmp15_) {
		_tmp14_ = TRUE;
	} else {
		gboolean _tmp16_ = FALSE;
		_tmp16_ = urgent;
		_tmp14_ = _tmp16_;
	}
	_tmp17_ = _tmp14_;
	if (_tmp17_) {
		GList* _tmp18_ = NULL;
		_tmp18_ = windows;
		{
			GList* window_collection = NULL;
			GList* window_it = NULL;
			window_collection = _tmp18_;
			for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
				WnckWindow* window = NULL;
				window = (WnckWindow*) window_it->data;
				{
					gboolean _tmp19_ = FALSE;
					gboolean _tmp20_ = FALSE;
					gboolean _tmp23_ = FALSE;
					WnckWindow* _tmp24_ = NULL;
					gboolean _tmp25_ = FALSE;
					_tmp20_ = urgent;
					if (_tmp20_) {
						WnckWindow* _tmp21_ = NULL;
						gboolean _tmp22_ = FALSE;
						_tmp21_ = window;
						_tmp22_ = wnck_window_needs_attention (_tmp21_);
						_tmp19_ = !_tmp22_;
					} else {
						_tmp19_ = FALSE;
					}
					_tmp23_ = _tmp19_;
					if (_tmp23_) {
						continue;
					}
					_tmp24_ = window;
					_tmp25_ = wnck_window_is_skip_tasklist (_tmp24_);
					if (!_tmp25_) {
						WnckWindow* _tmp26_ = NULL;
						GList* _tmp27_ = NULL;
						_tmp26_ = window;
						_tmp27_ = windows;
						plank_services_windows_window_control_intelligent_focus_off_viewport_window (_tmp26_, _tmp27_);
						_g_list_free0 (windows);
						return;
					}
				}
			}
		}
	}
	_tmp28_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp28_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp29_ = FALSE;
				WnckWindow* _tmp30_ = NULL;
				gboolean _tmp31_ = FALSE;
				gboolean _tmp37_ = FALSE;
				_tmp30_ = window;
				_tmp31_ = wnck_window_is_minimized (_tmp30_);
				if (_tmp31_) {
					WnckWindow* _tmp32_ = NULL;
					WnckWindow* _tmp33_ = NULL;
					WnckScreen* _tmp34_ = NULL;
					WnckWorkspace* _tmp35_ = NULL;
					gboolean _tmp36_ = FALSE;
					_tmp32_ = window;
					_tmp33_ = window;
					_tmp34_ = wnck_window_get_screen (_tmp33_);
					_tmp35_ = wnck_screen_get_active_workspace (_tmp34_);
					_tmp36_ = wnck_window_is_in_viewport (_tmp32_, _tmp35_);
					_tmp29_ = _tmp36_;
				} else {
					_tmp29_ = FALSE;
				}
				_tmp37_ = _tmp29_;
				if (_tmp37_) {
					GList* _tmp38_ = NULL;
					_tmp38_ = windows;
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
						w_collection = _tmp38_;
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
							WnckWindow* w = NULL;
							w = (WnckWindow*) w_it->data;
							{
								gboolean _tmp39_ = FALSE;
								WnckWindow* _tmp40_ = NULL;
								gboolean _tmp41_ = FALSE;
								gboolean _tmp47_ = FALSE;
								_tmp40_ = w;
								_tmp41_ = wnck_window_is_minimized (_tmp40_);
								if (_tmp41_) {
									WnckWindow* _tmp42_ = NULL;
									WnckWindow* _tmp43_ = NULL;
									WnckScreen* _tmp44_ = NULL;
									WnckWorkspace* _tmp45_ = NULL;
									gboolean _tmp46_ = FALSE;
									_tmp42_ = w;
									_tmp43_ = w;
									_tmp44_ = wnck_window_get_screen (_tmp43_);
									_tmp45_ = wnck_screen_get_active_workspace (_tmp44_);
									_tmp46_ = wnck_window_is_in_viewport (_tmp42_, _tmp45_);
									_tmp39_ = _tmp46_;
								} else {
									_tmp39_ = FALSE;
								}
								_tmp47_ = _tmp39_;
								if (_tmp47_) {
									WnckWindow* _tmp48_ = NULL;
									guint32 _tmp49_ = 0U;
									_tmp48_ = w;
									_tmp49_ = gtk_get_current_event_time ();
									wnck_window_unminimize (_tmp48_, _tmp49_);
									g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
								}
							}
						}
					}
					_g_list_free0 (windows);
					return;
				}
			}
		}
	}
	_tmp50_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp50_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp51_ = FALSE;
				gboolean _tmp52_ = FALSE;
				WnckWindow* _tmp53_ = NULL;
				gboolean _tmp54_ = FALSE;
				gboolean _tmp60_ = FALSE;
				gboolean _tmp64_ = FALSE;
				_tmp53_ = window;
				_tmp54_ = wnck_window_is_active (_tmp53_);
				if (_tmp54_) {
					WnckWindow* _tmp55_ = NULL;
					WnckWindow* _tmp56_ = NULL;
					WnckScreen* _tmp57_ = NULL;
					WnckWorkspace* _tmp58_ = NULL;
					gboolean _tmp59_ = FALSE;
					_tmp55_ = window;
					_tmp56_ = window;
					_tmp57_ = wnck_window_get_screen (_tmp56_);
					_tmp58_ = wnck_screen_get_active_workspace (_tmp57_);
					_tmp59_ = wnck_window_is_in_viewport (_tmp55_, _tmp58_);
					_tmp52_ = _tmp59_;
				} else {
					_tmp52_ = FALSE;
				}
				_tmp60_ = _tmp52_;
				if (_tmp60_) {
					_tmp51_ = TRUE;
				} else {
					WnckWindow* _tmp61_ = NULL;
					WnckScreen* _tmp62_ = NULL;
					WnckWindow* _tmp63_ = NULL;
					_tmp61_ = window;
					_tmp62_ = wnck_screen_get_default ();
					_tmp63_ = wnck_screen_get_active_window (_tmp62_);
					_tmp51_ = _tmp61_ == _tmp63_;
				}
				_tmp64_ = _tmp51_;
				if (_tmp64_) {
					GList* _tmp65_ = NULL;
					_tmp65_ = windows;
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
						w_collection = _tmp65_;
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
							WnckWindow* w = NULL;
							w = (WnckWindow*) w_it->data;
							{
								gboolean _tmp66_ = FALSE;
								WnckWindow* _tmp67_ = NULL;
								gboolean _tmp68_ = FALSE;
								gboolean _tmp74_ = FALSE;
								_tmp67_ = w;
								_tmp68_ = wnck_window_is_minimized (_tmp67_);
								if (!_tmp68_) {
									WnckWindow* _tmp69_ = NULL;
									WnckWindow* _tmp70_ = NULL;
									WnckScreen* _tmp71_ = NULL;
									WnckWorkspace* _tmp72_ = NULL;
									gboolean _tmp73_ = FALSE;
									_tmp69_ = w;
									_tmp70_ = w;
									_tmp71_ = wnck_window_get_screen (_tmp70_);
									_tmp72_ = wnck_screen_get_active_workspace (_tmp71_);
									_tmp73_ = wnck_window_is_in_viewport (_tmp69_, _tmp72_);
									_tmp66_ = _tmp73_;
								} else {
									_tmp66_ = FALSE;
								}
								_tmp74_ = _tmp66_;
								if (_tmp74_) {
									WnckWindow* _tmp75_ = NULL;
									_tmp75_ = w;
									wnck_window_minimize (_tmp75_);
									g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
								}
							}
						}
					}
					_g_list_free0 (windows);
					return;
				}
			}
		}
	}
	_tmp76_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp76_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWindow* _tmp77_ = NULL;
				WnckWindow* _tmp78_ = NULL;
				WnckScreen* _tmp79_ = NULL;
				WnckWorkspace* _tmp80_ = NULL;
				gboolean _tmp81_ = FALSE;
				_tmp77_ = window;
				_tmp78_ = window;
				_tmp79_ = wnck_window_get_screen (_tmp78_);
				_tmp80_ = wnck_screen_get_active_workspace (_tmp79_);
				_tmp81_ = wnck_window_is_in_viewport (_tmp77_, _tmp80_);
				if (_tmp81_) {
					GList* _tmp82_ = NULL;
					_tmp82_ = windows;
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
						w_collection = _tmp82_;
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
							WnckWindow* w = NULL;
							w = (WnckWindow*) w_it->data;
							{
								WnckWindow* _tmp83_ = NULL;
								WnckWindow* _tmp84_ = NULL;
								WnckScreen* _tmp85_ = NULL;
								WnckWorkspace* _tmp86_ = NULL;
								gboolean _tmp87_ = FALSE;
								_tmp83_ = w;
								_tmp84_ = w;
								_tmp85_ = wnck_window_get_screen (_tmp84_);
								_tmp86_ = wnck_screen_get_active_workspace (_tmp85_);
								_tmp87_ = wnck_window_is_in_viewport (_tmp83_, _tmp86_);
								if (_tmp87_) {
									WnckWindow* _tmp88_ = NULL;
									_tmp88_ = w;
									plank_services_windows_window_control_center_and_focus_window (_tmp88_);
									g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
								}
							}
						}
					}
					_g_list_free0 (windows);
					return;
				}
			}
		}
	}
	_tmp89_ = windows;
	_tmp90_ = g_list_nth_data (_tmp89_, (guint) 0);
	_tmp91_ = windows;
	plank_services_windows_window_control_intelligent_focus_off_viewport_window ((WnckWindow*) _tmp90_, _tmp91_);
	_g_list_free0 (windows);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean __lambda2_ (void) {
	gboolean result = FALSE;
	WnckWindow* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	plank_services_windows_window_control_delayed_focus_timer = (guint) 0;
	_tmp0_ = plank_services_windows_window_control_delayed_focus_window;
	_tmp1_ = gtk_get_current_event_time ();
	wnck_window_activate (_tmp0_, _tmp1_);
	_g_object_unref0 (plank_services_windows_window_control_delayed_focus_window);
	plank_services_windows_window_control_delayed_focus_window = NULL;
	result = FALSE;
	return result;
}


static gboolean ___lambda2__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda2_ ();
	return result;
}


static void plank_services_windows_window_control_intelligent_focus_off_viewport_window (WnckWindow* targetWindow, GList* additional_windows) {
	GList* _tmp0_ = NULL;
	WnckWindow* _tmp9_ = NULL;
	GList* _tmp10_ = NULL;
	guint _tmp11_ = 0U;
	guint _tmp12_ = 0U;
	WnckWindow* _tmp14_ = NULL;
	WnckWindow* _tmp15_ = NULL;
	guint _tmp16_ = 0U;
	g_return_if_fail (targetWindow != NULL);
	additional_windows = g_list_reverse (additional_windows);
	_tmp0_ = additional_windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp0_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp1_ = FALSE;
				WnckWindow* _tmp2_ = NULL;
				gboolean _tmp3_ = FALSE;
				gboolean _tmp7_ = FALSE;
				_tmp2_ = window;
				_tmp3_ = wnck_window_is_minimized (_tmp2_);
				if (!_tmp3_) {
					WnckWindow* _tmp4_ = NULL;
					WnckWindow* _tmp5_ = NULL;
					gboolean _tmp6_ = FALSE;
					_tmp4_ = targetWindow;
					_tmp5_ = window;
					_tmp6_ = plank_services_windows_window_control_windows_share_viewport (_tmp4_, _tmp5_);
					_tmp1_ = _tmp6_;
				} else {
					_tmp1_ = FALSE;
				}
				_tmp7_ = _tmp1_;
				if (_tmp7_) {
					WnckWindow* _tmp8_ = NULL;
					_tmp8_ = window;
					plank_services_windows_window_control_center_and_focus_window (_tmp8_);
					g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
				}
			}
		}
	}
	_tmp9_ = targetWindow;
	plank_services_windows_window_control_center_and_focus_window (_tmp9_);
	_tmp10_ = additional_windows;
	_tmp11_ = g_list_length (_tmp10_);
	if (_tmp11_ <= ((guint) 1)) {
		return;
	}
	_tmp12_ = plank_services_windows_window_control_delayed_focus_timer;
	if (_tmp12_ > ((guint) 0)) {
		guint _tmp13_ = 0U;
		_tmp13_ = plank_services_windows_window_control_delayed_focus_timer;
		g_source_remove (_tmp13_);
	}
	_tmp14_ = targetWindow;
	_tmp15_ = _g_object_ref0 (_tmp14_);
	_g_object_unref0 (plank_services_windows_window_control_delayed_focus_window);
	plank_services_windows_window_control_delayed_focus_window = _tmp15_;
	_tmp16_ = gdk_threads_add_timeout (PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY, ___lambda2__gsource_func, NULL);
	plank_services_windows_window_control_delayed_focus_timer = _tmp16_;
}


static gboolean plank_services_windows_window_control_windows_share_viewport (WnckWindow* first, WnckWindow* second) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	WnckWindow* _tmp1_ = NULL;
	gboolean _tmp3_ = FALSE;
	WnckWorkspace* wksp = NULL;
	WnckWindow* _tmp4_ = NULL;
	WnckWorkspace* _tmp5_ = NULL;
	WnckWorkspace* _tmp6_ = NULL;
	WnckWorkspace* _tmp9_ = NULL;
	GdkRectangle firstGeo = {0};
	GdkRectangle secondGeo = {0};
	WnckWindow* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	WnckWindow* _tmp15_ = NULL;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	gint _tmp20_ = 0;
	WnckWorkspace* _tmp21_ = NULL;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
	WnckWorkspace* _tmp24_ = NULL;
	gint _tmp25_ = 0;
	gint _tmp26_ = 0;
	WnckWorkspace* _tmp27_ = NULL;
	gint _tmp28_ = 0;
	gint _tmp29_ = 0;
	WnckWorkspace* _tmp30_ = NULL;
	gint _tmp31_ = 0;
	gint viewportWidth = 0;
	WnckWindow* _tmp32_ = NULL;
	WnckScreen* _tmp33_ = NULL;
	gint _tmp34_ = 0;
	gint viewportHeight = 0;
	WnckWindow* _tmp35_ = NULL;
	WnckScreen* _tmp36_ = NULL;
	gint _tmp37_ = 0;
	gint firstViewportX = 0;
	GdkRectangle _tmp38_ = {0};
	gint _tmp39_ = 0;
	GdkRectangle _tmp40_ = {0};
	gint _tmp41_ = 0;
	gint _tmp42_ = 0;
	gint _tmp43_ = 0;
	gint firstViewportY = 0;
	GdkRectangle _tmp44_ = {0};
	gint _tmp45_ = 0;
	GdkRectangle _tmp46_ = {0};
	gint _tmp47_ = 0;
	gint _tmp48_ = 0;
	gint _tmp49_ = 0;
	GdkRectangle viewpRect = {0};
	gint _tmp50_ = 0;
	gint _tmp51_ = 0;
	gint _tmp52_ = 0;
	gint _tmp53_ = 0;
	GdkRectangle _tmp54_ = {0};
	gboolean _tmp55_ = FALSE;
	_tmp1_ = first;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		WnckWindow* _tmp2_ = NULL;
		_tmp2_ = second;
		_tmp0_ = _tmp2_ == NULL;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		result = FALSE;
		return result;
	}
	_tmp4_ = first;
	_tmp5_ = wnck_window_get_workspace (_tmp4_);
	wksp = _tmp5_;
	_tmp6_ = wksp;
	if (_tmp6_ == NULL) {
		WnckWindow* _tmp7_ = NULL;
		WnckWorkspace* _tmp8_ = NULL;
		_tmp7_ = second;
		_tmp8_ = wnck_window_get_workspace (_tmp7_);
		wksp = _tmp8_;
	}
	_tmp9_ = wksp;
	if (_tmp9_ == NULL) {
		result = FALSE;
		return result;
	}
	memset (&firstGeo, 0, sizeof (GdkRectangle));
	memset (&secondGeo, 0, sizeof (GdkRectangle));
	_tmp10_ = first;
	wnck_window_get_geometry (_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
	firstGeo.x = _tmp11_;
	firstGeo.y = _tmp12_;
	firstGeo.width = _tmp13_;
	firstGeo.height = _tmp14_;
	_tmp15_ = second;
	wnck_window_get_geometry (_tmp15_, &_tmp16_, &_tmp17_, &_tmp18_, &_tmp19_);
	secondGeo.x = _tmp16_;
	secondGeo.y = _tmp17_;
	secondGeo.width = _tmp18_;
	secondGeo.height = _tmp19_;
	_tmp20_ = firstGeo.x;
	_tmp21_ = wksp;
	_tmp22_ = wnck_workspace_get_viewport_x (_tmp21_);
	firstGeo.x = _tmp20_ + _tmp22_;
	_tmp23_ = firstGeo.y;
	_tmp24_ = wksp;
	_tmp25_ = wnck_workspace_get_viewport_y (_tmp24_);
	firstGeo.y = _tmp23_ + _tmp25_;
	_tmp26_ = secondGeo.x;
	_tmp27_ = wksp;
	_tmp28_ = wnck_workspace_get_viewport_x (_tmp27_);
	secondGeo.x = _tmp26_ + _tmp28_;
	_tmp29_ = secondGeo.y;
	_tmp30_ = wksp;
	_tmp31_ = wnck_workspace_get_viewport_y (_tmp30_);
	secondGeo.y = _tmp29_ + _tmp31_;
	_tmp32_ = first;
	_tmp33_ = wnck_window_get_screen (_tmp32_);
	_tmp34_ = wnck_screen_get_width (_tmp33_);
	viewportWidth = _tmp34_;
	_tmp35_ = first;
	_tmp36_ = wnck_window_get_screen (_tmp35_);
	_tmp37_ = wnck_screen_get_height (_tmp36_);
	viewportHeight = _tmp37_;
	_tmp38_ = firstGeo;
	_tmp39_ = _tmp38_.x;
	_tmp40_ = firstGeo;
	_tmp41_ = _tmp40_.width;
	_tmp42_ = viewportWidth;
	_tmp43_ = viewportWidth;
	firstViewportX = ((_tmp39_ + (_tmp41_ / 2)) / _tmp42_) * _tmp43_;
	_tmp44_ = firstGeo;
	_tmp45_ = _tmp44_.y;
	_tmp46_ = firstGeo;
	_tmp47_ = _tmp46_.height;
	_tmp48_ = viewportHeight;
	_tmp49_ = viewportHeight;
	firstViewportY = ((_tmp45_ + (_tmp47_ / 2)) / _tmp48_) * _tmp49_;
	memset (&viewpRect, 0, sizeof (GdkRectangle));
	_tmp50_ = firstViewportX;
	viewpRect.x = _tmp50_;
	_tmp51_ = firstViewportY;
	viewpRect.y = _tmp51_;
	_tmp52_ = viewportWidth;
	viewpRect.width = _tmp52_;
	_tmp53_ = viewportHeight;
	viewpRect.height = _tmp53_;
	_tmp54_ = secondGeo;
	_tmp55_ = gdk_rectangle_intersect (&viewpRect, &_tmp54_, NULL);
	result = _tmp55_;
	return result;
}


static void plank_services_windows_window_control_center_and_focus_window (WnckWindow* w) {
	guint32 time = 0U;
	guint32 _tmp0_ = 0U;
	WnckWorkspace* workspace = NULL;
	WnckWindow* _tmp1_ = NULL;
	WnckWorkspace* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	WnckWorkspace* _tmp4_ = NULL;
	gboolean _tmp9_ = FALSE;
	WnckWindow* _tmp12_ = NULL;
	gboolean _tmp13_ = FALSE;
	WnckWindow* _tmp16_ = NULL;
	guint32 _tmp17_ = 0U;
	g_return_if_fail (w != NULL);
	_tmp0_ = gtk_get_current_event_time ();
	time = _tmp0_;
	_tmp1_ = w;
	_tmp2_ = wnck_window_get_workspace (_tmp1_);
	workspace = _tmp2_;
	_tmp4_ = workspace;
	if (_tmp4_ != NULL) {
		WnckWorkspace* _tmp5_ = NULL;
		WnckWindow* _tmp6_ = NULL;
		WnckScreen* _tmp7_ = NULL;
		WnckWorkspace* _tmp8_ = NULL;
		_tmp5_ = workspace;
		_tmp6_ = w;
		_tmp7_ = wnck_window_get_screen (_tmp6_);
		_tmp8_ = wnck_screen_get_active_workspace (_tmp7_);
		_tmp3_ = _tmp5_ != _tmp8_;
	} else {
		_tmp3_ = FALSE;
	}
	_tmp9_ = _tmp3_;
	if (_tmp9_) {
		WnckWorkspace* _tmp10_ = NULL;
		guint32 _tmp11_ = 0U;
		_tmp10_ = workspace;
		_tmp11_ = time;
		wnck_workspace_activate (_tmp10_, _tmp11_);
	}
	_tmp12_ = w;
	_tmp13_ = wnck_window_is_minimized (_tmp12_);
	if (_tmp13_) {
		WnckWindow* _tmp14_ = NULL;
		guint32 _tmp15_ = 0U;
		_tmp14_ = w;
		_tmp15_ = time;
		wnck_window_unminimize (_tmp14_, _tmp15_);
	}
	_tmp16_ = w;
	_tmp17_ = time;
	wnck_window_activate_transient (_tmp16_, _tmp17_);
}


void plank_services_windows_window_control_get_easy_geometry (WnckWindow* w, GdkRectangle* result) {
	GdkRectangle geo = {0};
	WnckWindow* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	g_return_if_fail (w != NULL);
	memset (&geo, 0, sizeof (GdkRectangle));
	_tmp0_ = w;
	wnck_window_get_geometry (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
	geo.x = _tmp1_;
	geo.y = _tmp2_;
	geo.width = _tmp3_;
	geo.height = _tmp4_;
	*result = geo;
	return;
}


static void plank_services_windows_window_control_class_init (PlankServicesWindowsWindowControlClass * klass) {
	plank_services_windows_window_control_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = plank_services_windows_window_control_finalize;
}


static void plank_services_windows_window_control_instance_init (PlankServicesWindowsWindowControl * self) {
}


static void plank_services_windows_window_control_finalize (GObject* obj) {
	PlankServicesWindowsWindowControl * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL, PlankServicesWindowsWindowControl);
	G_OBJECT_CLASS (plank_services_windows_window_control_parent_class)->finalize (obj);
}


GType plank_services_windows_window_control_get_type (void) {
	static volatile gsize plank_services_windows_window_control_type_id__volatile = 0;
	if (g_once_init_enter (&plank_services_windows_window_control_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankServicesWindowsWindowControlClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_services_windows_window_control_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankServicesWindowsWindowControl), 0, (GInstanceInitFunc) plank_services_windows_window_control_instance_init, NULL };
		GType plank_services_windows_window_control_type_id;
		plank_services_windows_window_control_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankServicesWindowsWindowControl", &g_define_type_info, 0);
		g_once_init_leave (&plank_services_windows_window_control_type_id__volatile, plank_services_windows_window_control_type_id);
	}
	return plank_services_windows_window_control_type_id__volatile;
}



